import java.util.Vector; 
import java.io.*; 
import java.util.Collections; 

/* Copyright K Lano 2012-2019
   package: TransformationSynthesis
*/ 


public class CorrelationPattern
{ String name; 
  String description; 
  Vector sourceEntities; // of Entity
  Vector targetEntities; // of Entity
  Vector sourceFeatures; // of ModelElement (Attribute or Association)
  Vector targetFeatures; // of ModelElement (Attribute or Association)

  public CorrelationPattern(String n, String d)
  { name = n; 
    description = d; 
    sourceEntities = new Vector(); 
    targetEntities = new Vector(); 
    sourceFeatures = new Vector(); 
    targetFeatures = new Vector(); 
  } 

  public String toString()
  { return "Correlation pattern " + name + " \n" + description; } 

  public boolean equals(Object x) 
  { if (x instanceof CorrelationPattern) 
    { return (x + "").equals(toString()); } 
    return false; 
  } 

  public void addSourceEntity(Entity e) 
  { sourceEntities.add(e); } 

  public void addSourceEntities(Vector es) 
  { sourceEntities.addAll(es); } 

  public void addTargetEntity(Entity e) 
  { targetEntities.add(e); } 

  public void addTargetEntities(Vector et) 
  { targetEntities.addAll(et); } 

  public void addSourceFeature(ModelElement e) 
  { sourceFeatures.add(e); } 

  public void addTargetFeature(ModelElement e) 
  { targetFeatures.add(e); } 
} 
