import java.util.List;
import java.util.Date;
import java.util.Map;
import java.util.HashMap;
import java.util.Vector;

import java.lang.*;
import java.lang.reflect.*;
import java.util.StringTokenizer;
import java.io.*;



class PermutationIterator
  extends AbstractForwardIterator
  implements SystemTypes
{
  private List basesq = new Vector(); // internal
  private List word = new Vector(); // internal
  private LexicographicOrdering lex;

  public PermutationIterator(LexicographicOrdering lex)
  {
    this.basesq = (new SystemTypes.Set()).getElements();
    this.word = (new SystemTypes.Set()).getElements();
    this.lex = lex;

  }

  public PermutationIterator() { }



  public String toString()
  { String _res_ = "(PermutationIterator) ";
    _res_ = _res_ + basesq + ",";
    _res_ = _res_ + word;
    return _res_ + super.toString();
  }

  public static PermutationIterator parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = Set.tokeniseCSV(_line);
    PermutationIterator permutationiteratorx = new PermutationIterator();
    return permutationiteratorx;
  }


  public void writeCSV(PrintWriter _out)
  { PermutationIterator permutationiteratorx = this;
    _out.print("" + permutationiteratorx.basesq);
    _out.print(" , ");
    _out.print("" + permutationiteratorx.word);
    _out.println();
  }


  public void setbasesq(List basesq_x) { basesq = basesq_x;  }


  

  

  public void setword(List word_x) { word = word_x;  }


    public void addword(String word_x)
  { word.add(word_x); }

  public void removeword(String word_x)
  { word.remove(word_x); }



  

  public void setlex(LexicographicOrdering lex_xx) { lex = lex_xx;
  }

  public static void setAlllex(List permutationiterators, LexicographicOrdering _val)
  { for (int _i = 0; _i < permutationiterators.size(); _i++)
    { PermutationIterator permutationiteratorx = (PermutationIterator) permutationiterators.get(_i);
      Controller.inst().setlex(permutationiteratorx, _val); } }

    public List getbasesq() { return basesq; }

  

  

    public List getword() { return word; }

  

  

  public LexicographicOrdering getlex() { return lex; }

  public static List getAlllex(List permutationiterators)
  { List result = new Vector();
    for (int _i = 0; _i < permutationiterators.size(); _i++)
    { PermutationIterator permutationiteratorx = (PermutationIterator) permutationiterators.get(_i);
      if (result.contains(permutationiteratorx.getlex())) {}
      else { result.add(permutationiteratorx.getlex()); }
 }
    return result; }

  public static List getAllOrderedlex(List permutationiterators)
  { List result = new Vector();
    for (int _i = 0; _i < permutationiterators.size(); _i++)
    { PermutationIterator permutationiteratorx = (PermutationIterator) permutationiterators.get(_i);
      if (result.contains(permutationiteratorx.getlex())) {}
      else { result.add(permutationiteratorx.getlex()); }
 }
    return result; }

    public void init()
  { LexicographicOrdering x = new LexicographicOrdering();
    Controller.inst().addLexicographicOrdering(x);
    Controller.inst().setalphabet(x,Set.collect_0(this.getbasesq()));
    Controller.inst().setn(x,this.getbasesq().size());
    Controller.inst().setlex(this,x);
  }

    public void start()
  { Controller.inst().init(this.getlex());
    Controller.inst().setword(this,this.getlex().getalphabet());
  }

    public void next()
  { Controller.inst().setword(this,this.getlex().increment(this.getword()));
  }

    public List element()
  {   List result = new Vector();
 
  result = word;
    return result;
  }


    public boolean atEnd()
  {   boolean result = false;
 
  if (word.equals(Set.reverse(lex.getalphabet()))) 
  {   result = true;
 
  }    return result;
  }



}


class LexicographicOrdering
  implements SystemTypes
{
  private List alphabet = new Vector(); // internal
  private int n = 0; // internal

  public LexicographicOrdering()
  {
    this.alphabet = (new SystemTypes.Set()).getElements();
    this.n = 0;

  }



  public String toString()
  { String _res_ = "(LexicographicOrdering) ";
    _res_ = _res_ + alphabet + ",";
    _res_ = _res_ + n;
    return _res_;
  }

  public static LexicographicOrdering parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = Set.tokeniseCSV(_line);
    LexicographicOrdering lexicographicorderingx = new LexicographicOrdering();
    lexicographicorderingx.n = Integer.parseInt((String) _line1vals.get(1));
    return lexicographicorderingx;
  }


  public void writeCSV(PrintWriter _out)
  { LexicographicOrdering lexicographicorderingx = this;
    _out.print("" + lexicographicorderingx.alphabet);
    _out.print(" , ");
    _out.print("" + lexicographicorderingx.n);
    _out.println();
  }


  public void setalphabet(List alphabet_x) { alphabet = alphabet_x;  }


    public void addalphabet(String alphabet_x)
  { alphabet.add(alphabet_x); }

  public void removealphabet(String alphabet_x)
  { alphabet.remove(alphabet_x); }



  

  public void setn(int n_x) { n = n_x;  }


    public static void setAlln(List lexicographicorderings,int val)
  { for (int i = 0; i < lexicographicorderings.size(); i++)
    { LexicographicOrdering lexicographicorderingx = (LexicographicOrdering) lexicographicorderings.get(i);
      Controller.inst().setn(lexicographicorderingx,val); } }


    public List getalphabet() { return alphabet; }

  

  

    public int getn() { return n; }

    public static List getAlln(List lexicographicorderings)
  { List result = new Vector();
    for (int i = 0; i < lexicographicorderings.size(); i++)
    { LexicographicOrdering lexicographicorderingx = (LexicographicOrdering) lexicographicorderings.get(i);
      if (result.contains(new Integer(lexicographicorderingx.getn()))) { }
      else { result.add(new Integer(lexicographicorderingx.getn())); } }
    return result; }

    public static List getAllOrderedn(List lexicographicorderings)
  { List result = new Vector();
    for (int i = 0; i < lexicographicorderings.size(); i++)
    { LexicographicOrdering lexicographicorderingx = (LexicographicOrdering) lexicographicorderings.get(i);
      result.add(new Integer(lexicographicorderingx.getn())); } 
    return result; }

    public void init()
  { Controller.inst().setn(this,this.getalphabet().size());
  }

    public List incrementRec(List s)
  {   List result = new Vector();
    if (s.size() <= 0) { return result; } 
   
  int ind = (alphabet.indexOf(((String) Set.last(s))) + 1); 
     if (ind < n) 
  {   result = Set.concatenate(Set.front(s),(new SystemTypes.Set()).add(((String) alphabet.get(ind + 1 - 1))).getElements());
 
  }  else
      if (ind == n) 
  {   result = Set.concatenate(this.increment(Set.front(s)),(new SystemTypes.Set()).add(((String) alphabet.get(1 - 1))).getElements());
 
  }          return result;
  }


    public List increment(List s)
  {   List result = new Vector();
 
  if (s.size() == 0) 
  {   result = (new SystemTypes.Set()).add(((String) alphabet.get(1 - 1))).getElements();
 
  }  else
      if (s.size() > 0) 
  {   result = this.incrementRec(s);
 
  }       return result;
  }


    public boolean noduplicates(List s)
  {   boolean result = false;
 
  List st = Set.asSet(s); 
     if (st.size() == s.size()) 
  {   result = true;
 
  }       return result;
  }



}


abstract class AbstractForwardIterator
  implements SystemTypes
{

  public AbstractForwardIterator()
  {

  }



  public String toString()
  { String _res_ = "(AbstractForwardIterator) ";
    return _res_;
  }



    public void init()
  { {} /* No update form for: true */
  }

    public void start()
  { {} /* No update form for: true */
  }

    public void next()
  { {} /* No update form for: true */
  }

    public List element()
  {   List result = new Vector();
 
  
    return result;
  }


    public boolean atEnd()
  {   boolean result = false;
 
  result = true;
    return result;
  }



}



public class Controller implements SystemTypes, ControllerInterface
{
  Vector permutationiterators = new Vector();
  Vector lexicographicorderings = new Vector();
  Vector abstractforwarditerators = new Vector();
  private static Controller uniqueInstance; 


  private Controller() { } 


  public static Controller inst() 
    { if (uniqueInstance == null) 
    { uniqueInstance = new Controller(); }
    return uniqueInstance; } 


  public static void loadModel(String file)
  {
    try
    { BufferedReader br = null;
      File f = new File(file);
      try 
      { br = new BufferedReader(new FileReader(f)); }
      catch (Exception ex) 
      { System.err.println("No file: " + file); return; }
      Class cont = Class.forName("Controller");
      java.util.Map objectmap = new java.util.HashMap();
      while (true)
      { String line1;
        try { line1 = br.readLine(); }
        catch (Exception e)
        { return; }
        if (line1 == null)
        { return; }
        line1 = line1.trim();

        if (line1.length() == 0) { continue; }
        if (line1.startsWith("//")) { continue; }
        String left;
        String op;
        String right;
        if (line1.charAt(line1.length() - 1) == '"')
        { int eqind = line1.indexOf("="); 
          if (eqind == -1) { continue; }
          else 
          { left = line1.substring(0,eqind-1).trim();
            op = "="; 
            right = line1.substring(eqind+1,line1.length()).trim();
          }
        }
        else
        { StringTokenizer st1 = new StringTokenizer(line1);
          Vector vals1 = new Vector();
          while (st1.hasMoreTokens())
          { String val1 = st1.nextToken();
            vals1.add(val1);
          }
          if (vals1.size() < 3)
          { continue; }
          left = (String) vals1.get(0);
          op = (String) vals1.get(1);
          right = (String) vals1.get(2);
        }
        if (":".equals(op))
        { int i2 = right.indexOf(".");
          if (i2 == -1)
          { Class cl;
            try { cl = Class.forName("" + right); }
            catch (Exception _x) { System.err.println("No entity: " + right); continue; }
            Object xinst = cl.newInstance();
            objectmap.put(left,xinst);
            Class[] cargs = new Class[] { cl };
            Method addC = null;
            try { addC = cont.getMethod("add" + right,cargs); }
            catch (Exception _xx) { System.err.println("No entity: " + right); continue; }
            if (addC == null) { continue; }
            Object[] args = new Object[] { xinst };
            addC.invoke(Controller.inst(),args);
          }
          else
          { String obj = right.substring(0,i2);
            String role = right.substring(i2+1,right.length());
            Object objinst = objectmap.get(obj); 
            if (objinst == null) 
            { continue; }
            Object val = objectmap.get(left);
            if (val == null) 
            { continue; }
            Class objC = objinst.getClass();
            Class typeclass = val.getClass(); 
            Object[] args = new Object[] { val }; 
            Class[] settypes = new Class[] { typeclass };
            Method addrole = Controller.findMethod(objC,"add" + role);
            if (addrole != null) 
            { addrole.invoke(objinst, args); }
            else { System.err.println("Error: cannot add to " + role); }
          }
        }
        else if ("=".equals(op))
        { int i1 = left.indexOf(".");
          if (i1 == -1) 
          { continue; }
          String obj = left.substring(0,i1);
          String att = left.substring(i1+1,left.length());
          Object objinst = objectmap.get(obj); 
          if (objinst == null) 
          { System.err.println("No object: " + obj); continue; }
          Class objC = objinst.getClass();
          Class typeclass; 
          Object val; 
          if (right.charAt(0) == '"' &&
              right.charAt(right.length() - 1) == '"')
          { typeclass = String.class;
            val = right.substring(1,right.length() - 1);
          } 
          else if ("true".equals(right) || "false".equals(right))
          { typeclass = boolean.class;
            if ("true".equals(right))
            { val = new Boolean(true); }
            else
            { val = new Boolean(false); }
          }
          else 
          { val = objectmap.get(right);
            if (val != null)
            { typeclass = val.getClass(); }
            else 
            { int i;
              long l; 
              double d;
              try 
              { i = Integer.parseInt(right);
                typeclass = int.class;
                val = new Integer(i); 
              }
              catch (Exception ee)
              { try 
                { l = Long.parseLong(right);
                  typeclass = long.class;
                  val = new Long(l); 
                }
                catch (Exception eee)
                { try
                  { d = Double.parseDouble(right);
                    typeclass = double.class;
                    val = new Double(d);
                  }
                  catch (Exception ff)
                  { continue; }
                }
              }
            }
          }
          Object[] args = new Object[] { val }; 
          Class[] settypes = new Class[] { typeclass };
          Method setatt = Controller.findMethod(objC,"set" + att);
          if (setatt != null) 
          { setatt.invoke(objinst, args); }
          else { System.err.println("No attribute: " + objC.getName() + "::" + att); }
        }
      }
    } catch (Exception e) { }
  }

  public static Method findMethod(Class c, String name)
  { Method[] mets = c.getMethods(); 
    for (int i = 0; i < mets.length; i++)
    { Method m = mets[i];
      if (m.getName().equals(name))
      { return m; }
    } 
    return null;
  }


  public static void loadCSVModel()
  { boolean __eof = false;
    String __s = "";
    Controller __cont = Controller.inst();
    BufferedReader __br = null;
    try
    { File _permutationiterator = new File("PermutationIterator.csv");
      __br = new BufferedReader(new FileReader(_permutationiterator));
      __eof = false;
      while (!__eof)
      { try { __s = __br.readLine(); }
        catch (IOException __e)
        { System.out.println("Reading failed.");
          return;
        }
        if (__s == null)
        { __eof = true; }
        else
        { PermutationIterator permutationiteratorx = PermutationIterator.parseCSV(__s.trim());
          if (permutationiteratorx != null)
          { __cont.addPermutationIterator(permutationiteratorx); }
        }
      }
    }
    catch(Exception __e) { }
    try
    { File _lexicographicordering = new File("LexicographicOrdering.csv");
      __br = new BufferedReader(new FileReader(_lexicographicordering));
      __eof = false;
      while (!__eof)
      { try { __s = __br.readLine(); }
        catch (IOException __e)
        { System.out.println("Reading failed.");
          return;
        }
        if (__s == null)
        { __eof = true; }
        else
        { LexicographicOrdering lexicographicorderingx = LexicographicOrdering.parseCSV(__s.trim());
          if (lexicographicorderingx != null)
          { __cont.addLexicographicOrdering(lexicographicorderingx); }
        }
      }
    }
    catch(Exception __e) { }
  }


  public void checkCompleteness()
  {   }


  public void saveModel(String file)
  { File outfile = new File(file); 
    PrintWriter out; 
    try { out = new PrintWriter(new BufferedWriter(new FileWriter(outfile))); }
    catch (Exception e) { return; } 
  for (int _i = 0; _i < permutationiterators.size(); _i++)
  { PermutationIterator permutationiteratorx_ = (PermutationIterator) permutationiterators.get(_i);
    out.println("permutationiteratorx_" + _i + " : PermutationIterator");
    List permutationiterator_basesq = permutationiteratorx_.getbasesq();
    for (int _j = 0; _j < permutationiterator_basesq.size(); _j++)
    { out.println(permutationiterator_basesq.get(_j) + " : permutationiteratorx_" + _i + ".basesq");
    }
    List permutationiterator_word = permutationiteratorx_.getword();
    for (int _j = 0; _j < permutationiterator_word.size(); _j++)
    { out.println("\"" + permutationiterator_word.get(_j) + "\" : permutationiteratorx_" + _i + ".word");
    }
  }

  for (int _i = 0; _i < lexicographicorderings.size(); _i++)
  { LexicographicOrdering lexicographicorderingx_ = (LexicographicOrdering) lexicographicorderings.get(_i);
    out.println("lexicographicorderingx_" + _i + " : LexicographicOrdering");
    List lexicographicordering_alphabet = lexicographicorderingx_.getalphabet();
    for (int _j = 0; _j < lexicographicordering_alphabet.size(); _j++)
    { out.println("\"" + lexicographicordering_alphabet.get(_j) + "\" : lexicographicorderingx_" + _i + ".alphabet");
    }
    out.println("lexicographicorderingx_" + _i + ".n = " + lexicographicorderingx_.getn());
  }

  for (int _i = 0; _i < permutationiterators.size(); _i++)
  { PermutationIterator permutationiteratorx_ = (PermutationIterator) permutationiterators.get(_i);
    out.println("permutationiteratorx_" + _i + ".lex = lexicographicorderingx_" + lexicographicorderings.indexOf(((PermutationIterator) permutationiterators.get(_i)).getlex()));
  }
    out.close(); 
  }


  public static void loadXSI()
  { boolean __eof = false;
    String __s = "";
    String xmlstring = "";
    BufferedReader __br = null;
    try
    { File _classmodel = new File("in.xmi");
      __br = new BufferedReader(new FileReader(_classmodel));
      __eof = false;
      while (!__eof)
      { try { __s = __br.readLine(); }
        catch (IOException __e)
        { System.out.println("Reading failed.");
          return;
        }
        if (__s == null)
        { __eof = true; }
        else
        { xmlstring = xmlstring + __s; }
      } 
      __br.close();
    } 
    catch (Exception _x) { }
    Vector res = convertXsiToVector(xmlstring);
    File outfile = new File("_in.txt");
    PrintWriter out; 
    try { out = new PrintWriter(new BufferedWriter(new FileWriter(outfile))); }
    catch (Exception e) { return; } 
    for (int i = 0; i < res.size(); i++)
    { String r = (String) res.get(i); 
      out.println(r);
    } 
    out.close();
    loadModel("_in.txt");
  }

  public static Vector convertXsiToVector(String xmlstring)
  { Vector res = new Vector();
    XMLParser comp = new XMLParser();
    comp.nospacelexicalanalysisxml(xmlstring);
    XMLNode xml = comp.parseXML();
    if (xml == null) { return res; } 
    java.util.Map instancemap = new java.util.HashMap(); // String --> Vector
    java.util.Map entmap = new java.util.HashMap();       // String --> String
    Vector entcodes = new Vector(); 
    java.util.Map allattsmap = new java.util.HashMap(); // String --> Vector
    java.util.Map stringattsmap = new java.util.HashMap(); // String --> Vector
    java.util.Map onerolesmap = new java.util.HashMap(); // String --> Vector
    java.util.Map actualtype = new java.util.HashMap(); // XMLNode --> String
    Vector eallatts = new Vector();
    instancemap.put("permutationiterators", new Vector()); 
    instancemap.put("permutationiterator",new Vector()); 
    entcodes.add("permutationiterators");
    entcodes.add("permutationiterator");
    entmap.put("permutationiterators","PermutationIterator");
    entmap.put("permutationiterator","PermutationIterator");
    eallatts = new Vector();
    eallatts.add("basesq");
    eallatts.add("word");
    allattsmap.put("PermutationIterator", eallatts);
    eallatts = new Vector();
    stringattsmap.put("PermutationIterator", eallatts);
    eallatts = new Vector();
    eallatts.add("lex");
    onerolesmap.put("PermutationIterator", eallatts);
    instancemap.put("lexicographicorderings", new Vector()); 
    instancemap.put("lexicographicordering",new Vector()); 
    entcodes.add("lexicographicorderings");
    entcodes.add("lexicographicordering");
    entmap.put("lexicographicorderings","LexicographicOrdering");
    entmap.put("lexicographicordering","LexicographicOrdering");
    eallatts = new Vector();
    eallatts.add("alphabet");
    eallatts.add("n");
    allattsmap.put("LexicographicOrdering", eallatts);
    eallatts = new Vector();
    stringattsmap.put("LexicographicOrdering", eallatts);
    eallatts = new Vector();
    onerolesmap.put("LexicographicOrdering", eallatts);
    instancemap.put("abstractforwarditerators", new Vector()); 
    instancemap.put("abstractforwarditerator",new Vector()); 
    entcodes.add("abstractforwarditerators");
    entcodes.add("abstractforwarditerator");
    entmap.put("abstractforwarditerators","AbstractForwardIterator");
    entmap.put("abstractforwarditerator","AbstractForwardIterator");
    eallatts = new Vector();
    allattsmap.put("AbstractForwardIterator", eallatts);
    eallatts = new Vector();
    stringattsmap.put("AbstractForwardIterator", eallatts);
    eallatts = new Vector();
    onerolesmap.put("AbstractForwardIterator", eallatts);
    eallatts = new Vector();
  Vector enodes = xml.getSubnodes();
  for (int i = 0; i < enodes.size(); i++)
  { XMLNode enode = (XMLNode) enodes.get(i);
    String cname = enode.getTag();
    Vector einstances = (Vector) instancemap.get(cname); 
    if (einstances == null) 
    { einstances = (Vector) instancemap.get(cname + "s"); }
    if (einstances != null) 
    { einstances.add(enode); }
  }
  for (int j = 0; j < entcodes.size(); j++)
  { String ename = (String) entcodes.get(j);
    Vector elems = (Vector) instancemap.get(ename);
    for (int k = 0; k < elems.size(); k++)
    { XMLNode enode = (XMLNode) elems.get(k);
      String tname = enode.getAttributeValue("xsi:type"); 
      if (tname == null) 
      { tname = (String) entmap.get(ename); } 
      else 
      { int colonind = tname.indexOf(":"); 
        if (colonind >= 0)
        { tname = tname.substring(colonind + 1,tname.length()); }
      }
      res.add(ename + k + " : " + tname);
      actualtype.put(enode,tname);
    }   
  }
  for (int j = 0; j < entcodes.size(); j++) 
  { String ename = (String) entcodes.get(j); 
    Vector elems = (Vector) instancemap.get(ename); 
    for (int k = 0; k < elems.size(); k++)
    { XMLNode enode = (XMLNode) elems.get(k);
      String tname = (String) actualtype.get(enode);
      Vector tallatts = (Vector)  allattsmap.get(tname);
      Vector tstringatts = (Vector)  stringattsmap.get(tname);
      Vector toneroles = (Vector)  onerolesmap.get(tname);
      Vector atts = enode.getAttributes();
      for (int p = 0; p < atts.size(); p++) 
      { XMLAttribute patt = (XMLAttribute) atts.get(p); 
        if (patt.getName().equals("xsi:type") || patt.getName().equals("xmi:id")) {} 
        else 
        { patt.getDataDeclarationFromXsi(res,tallatts,tstringatts,toneroles,ename + k, (String) entmap.get(ename)); } 
      }
    } 
  }  
  return res; } 

  public void saveXSI(String file)
  { File outfile = new File(file); 
    PrintWriter out; 
    try { out = new PrintWriter(new BufferedWriter(new FileWriter(outfile))); }
    catch (Exception e) { return; } 
    out.println("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
    out.println("<UMLRSDS:model xmi:version=\"2.0\" xmlns:xmi=\"http://www.omg.org/XMI\">");
    for (int _i = 0; _i < permutationiterators.size(); _i++)
    { PermutationIterator permutationiteratorx_ = (PermutationIterator) permutationiterators.get(_i);
       out.print("<permutationiterators xsi:type=\"My:PermutationIterator\"");
    out.print(" lex=\"");
    out.print("//@lexicographicorderings." + lexicographicorderings.indexOf(((PermutationIterator) permutationiterators.get(_i)).getlex()));
    out.print("\"");
    out.println(" />");
  }

    for (int _i = 0; _i < lexicographicorderings.size(); _i++)
    { LexicographicOrdering lexicographicorderingx_ = (LexicographicOrdering) lexicographicorderings.get(_i);
       out.print("<lexicographicorderings xsi:type=\"My:LexicographicOrdering\"");
    out.print(" n=\"" + lexicographicorderingx_.getn() + "\" ");
    out.println(" />");
  }

    out.println("</UMLRSDS:model>");
    out.close(); 
  }


  public void saveCSVModel()
  { try {
      File _permutationiterator = new File("PermutationIterator.csv");
      PrintWriter _out_permutationiterator = new PrintWriter(new BufferedWriter(new FileWriter(_permutationiterator)));
      for (int __i = 0; __i < permutationiterators.size(); __i++)
      { PermutationIterator permutationiteratorx = (PermutationIterator) permutationiterators.get(__i);
        permutationiteratorx.writeCSV(_out_permutationiterator);
      }
      _out_permutationiterator.close();
      File _lexicographicordering = new File("LexicographicOrdering.csv");
      PrintWriter _out_lexicographicordering = new PrintWriter(new BufferedWriter(new FileWriter(_lexicographicordering)));
      for (int __i = 0; __i < lexicographicorderings.size(); __i++)
      { LexicographicOrdering lexicographicorderingx = (LexicographicOrdering) lexicographicorderings.get(__i);
        lexicographicorderingx.writeCSV(_out_lexicographicordering);
      }
      _out_lexicographicordering.close();
    }
    catch(Exception __e) { }
  }



  public void addPermutationIterator(PermutationIterator oo) { permutationiterators.add(oo); addAbstractForwardIterator(oo); }

  public void addLexicographicOrdering(LexicographicOrdering oo) { lexicographicorderings.add(oo); }

  public void addAbstractForwardIterator(AbstractForwardIterator oo) { abstractforwarditerators.add(oo); }



  public PermutationIterator createPermutationIterator()
  { PermutationIterator permutationiteratorx = new PermutationIterator();
    addPermutationIterator(permutationiteratorx);
    return permutationiteratorx;
  }

  public LexicographicOrdering createLexicographicOrdering()
  { LexicographicOrdering lexicographicorderingx = new LexicographicOrdering();
    addLexicographicOrdering(lexicographicorderingx);
    return lexicographicorderingx;
  }


public void setbasesq(PermutationIterator permutationiteratorx, List basesq_x) 
  { permutationiteratorx.setbasesq(basesq_x);
    }


public void setword(PermutationIterator permutationiteratorx, List word_x) 
  { permutationiteratorx.setword(word_x);
    }


  public void addword(PermutationIterator permutationiteratorx, String word_x)
  { permutationiteratorx.addword(word_x); }


  public void removeword(PermutationIterator permutationiteratorx, String word_x)
  { permutationiteratorx.removeword(word_x); }


  public void setlex(PermutationIterator permutationiteratorx, LexicographicOrdering lexxx) 
  {   if (permutationiteratorx.getlex() == lexxx) { return; }
    permutationiteratorx.setlex(lexxx);
      }


public void setalphabet(LexicographicOrdering lexicographicorderingx, List alphabet_x) 
  { lexicographicorderingx.setalphabet(alphabet_x);
    }


  public void addalphabet(LexicographicOrdering lexicographicorderingx, String alphabet_x)
  { lexicographicorderingx.addalphabet(alphabet_x); }


  public void removealphabet(LexicographicOrdering lexicographicorderingx, String alphabet_x)
  { lexicographicorderingx.removealphabet(alphabet_x); }


public void setn(LexicographicOrdering lexicographicorderingx, int n_x) 
  { lexicographicorderingx.setn(n_x);
    }



  public void init(PermutationIterator permutationiteratorx)
  {   permutationiteratorx.init();
   }

  public  List AllPermutationIteratorinit(List permutationiteratorxs)
  { 
    List result = new Vector();
    for (int i = 0; i < permutationiteratorxs.size(); i++)
    { PermutationIterator permutationiteratorx = (PermutationIterator) permutationiteratorxs.get(i);
      init(permutationiteratorx);
    }
    return result; 
  }

  public void start(PermutationIterator permutationiteratorx)
  {   permutationiteratorx.start();
   }

  public  List AllPermutationIteratorstart(List permutationiteratorxs)
  { 
    List result = new Vector();
    for (int i = 0; i < permutationiteratorxs.size(); i++)
    { PermutationIterator permutationiteratorx = (PermutationIterator) permutationiteratorxs.get(i);
      start(permutationiteratorx);
    }
    return result; 
  }

  public void next(PermutationIterator permutationiteratorx)
  {   permutationiteratorx.next();
   }

  public  List AllPermutationIteratornext(List permutationiteratorxs)
  { 
    List result = new Vector();
    for (int i = 0; i < permutationiteratorxs.size(); i++)
    { PermutationIterator permutationiteratorx = (PermutationIterator) permutationiteratorxs.get(i);
      next(permutationiteratorx);
    }
    return result; 
  }

  public  List AllPermutationIteratorelement(List permutationiteratorxs)
  { 
    List result = new Vector();
    for (int _i = 0; _i < permutationiteratorxs.size(); _i++)
    { PermutationIterator permutationiteratorx = (PermutationIterator) permutationiteratorxs.get(_i);
      result.addAll(permutationiteratorx.element());
    }
    return result; 
  }

  public  List AllPermutationIteratoratEnd(List permutationiteratorxs)
  { 
    List result = new Vector();
    for (int _i = 0; _i < permutationiteratorxs.size(); _i++)
    { PermutationIterator permutationiteratorx = (PermutationIterator) permutationiteratorxs.get(_i);
      result.add(new Boolean(permutationiteratorx.atEnd()));
    }
    return result; 
  }

  public void init(LexicographicOrdering lexicographicorderingx)
  {   lexicographicorderingx.init();
   }

  public  List AllLexicographicOrderinginit(List lexicographicorderingxs)
  { 
    List result = new Vector();
    for (int i = 0; i < lexicographicorderingxs.size(); i++)
    { LexicographicOrdering lexicographicorderingx = (LexicographicOrdering) lexicographicorderingxs.get(i);
      init(lexicographicorderingx);
    }
    return result; 
  }

  public  List AllLexicographicOrderingincrementRec(List lexicographicorderingxs,List s)
  { 
    List result = new Vector();
    for (int _i = 0; _i < lexicographicorderingxs.size(); _i++)
    { LexicographicOrdering lexicographicorderingx = (LexicographicOrdering) lexicographicorderingxs.get(_i);
      result.addAll(lexicographicorderingx.incrementRec(s));
    }
    return result; 
  }

  public  List AllLexicographicOrderingincrement(List lexicographicorderingxs,List s)
  { 
    List result = new Vector();
    for (int _i = 0; _i < lexicographicorderingxs.size(); _i++)
    { LexicographicOrdering lexicographicorderingx = (LexicographicOrdering) lexicographicorderingxs.get(_i);
      result.addAll(lexicographicorderingx.increment(s));
    }
    return result; 
  }

  public  List AllLexicographicOrderingnoduplicates(List lexicographicorderingxs,List s)
  { 
    List result = new Vector();
    for (int _i = 0; _i < lexicographicorderingxs.size(); _i++)
    { LexicographicOrdering lexicographicorderingx = (LexicographicOrdering) lexicographicorderingxs.get(_i);
      result.add(new Boolean(lexicographicorderingx.noduplicates(s)));
    }
    return result; 
  }

  public void init(AbstractForwardIterator abstractforwarditeratorx)
  {   abstractforwarditeratorx.init();
   }

  public  List AllAbstractForwardIteratorinit(List abstractforwarditeratorxs)
  { 
    List result = new Vector();
    for (int i = 0; i < abstractforwarditeratorxs.size(); i++)
    { AbstractForwardIterator abstractforwarditeratorx = (AbstractForwardIterator) abstractforwarditeratorxs.get(i);
      init(abstractforwarditeratorx);
    }
    return result; 
  }

  public void start(AbstractForwardIterator abstractforwarditeratorx)
  {   abstractforwarditeratorx.start();
   }

  public  List AllAbstractForwardIteratorstart(List abstractforwarditeratorxs)
  { 
    List result = new Vector();
    for (int i = 0; i < abstractforwarditeratorxs.size(); i++)
    { AbstractForwardIterator abstractforwarditeratorx = (AbstractForwardIterator) abstractforwarditeratorxs.get(i);
      start(abstractforwarditeratorx);
    }
    return result; 
  }

  public void next(AbstractForwardIterator abstractforwarditeratorx)
  {   abstractforwarditeratorx.next();
   }

  public  List AllAbstractForwardIteratornext(List abstractforwarditeratorxs)
  { 
    List result = new Vector();
    for (int i = 0; i < abstractforwarditeratorxs.size(); i++)
    { AbstractForwardIterator abstractforwarditeratorx = (AbstractForwardIterator) abstractforwarditeratorxs.get(i);
      next(abstractforwarditeratorx);
    }
    return result; 
  }

  public  List AllAbstractForwardIteratorelement(List abstractforwarditeratorxs)
  { 
    List result = new Vector();
    for (int _i = 0; _i < abstractforwarditeratorxs.size(); _i++)
    { AbstractForwardIterator abstractforwarditeratorx = (AbstractForwardIterator) abstractforwarditeratorxs.get(_i);
      result.addAll(abstractforwarditeratorx.element());
    }
    return result; 
  }

  public  List AllAbstractForwardIteratoratEnd(List abstractforwarditeratorxs)
  { 
    List result = new Vector();
    for (int _i = 0; _i < abstractforwarditeratorxs.size(); _i++)
    { AbstractForwardIterator abstractforwarditeratorx = (AbstractForwardIterator) abstractforwarditeratorxs.get(_i);
      result.add(new Boolean(abstractforwarditeratorx.atEnd()));
    }
    return result; 
  }



  public void killAllPermutationIterator(List permutationiteratorxx)
  { for (int _i = 0; _i < permutationiteratorxx.size(); _i++)
    { killPermutationIterator((PermutationIterator) permutationiteratorxx.get(_i)); }
  }

  public void killPermutationIterator(PermutationIterator permutationiteratorxx)
  { if (permutationiteratorxx == null) { return; }
   permutationiterators.remove(permutationiteratorxx);
  killAbstractForwardIterator(permutationiteratorxx);
  }



  public void killAllLexicographicOrdering(List lexicographicorderingxx)
  { for (int _i = 0; _i < lexicographicorderingxx.size(); _i++)
    { killLexicographicOrdering((LexicographicOrdering) lexicographicorderingxx.get(_i)); }
  }

  public void killLexicographicOrdering(LexicographicOrdering lexicographicorderingxx)
  { if (lexicographicorderingxx == null) { return; }
   lexicographicorderings.remove(lexicographicorderingxx);
    Vector _1removedlexPermutationIterator = new Vector();
    Vector _1qrangelexPermutationIterator = new Vector();
    _1qrangelexPermutationIterator.addAll(permutationiterators);
    for (int _i = 0; _i < _1qrangelexPermutationIterator.size(); _i++)
    { PermutationIterator permutationiteratorx = (PermutationIterator) _1qrangelexPermutationIterator.get(_i);
      if (permutationiteratorx != null && lexicographicorderingxx.equals(permutationiteratorx.getlex()))
      { _1removedlexPermutationIterator.add(permutationiteratorx);
        permutationiteratorx.setlex(null);
      }
    }
    for (int _i = 0; _i < _1removedlexPermutationIterator.size(); _i++)
    { killPermutationIterator((PermutationIterator) _1removedlexPermutationIterator.get(_i)); }
  }



  public void killAllAbstractForwardIterator(List abstractforwarditeratorxx)
  { for (int _i = 0; _i < abstractforwarditeratorxx.size(); _i++)
    { killAbstractForwardIterator((AbstractForwardIterator) abstractforwarditeratorxx.get(_i)); }
  }

  public void killAbstractForwardIterator(AbstractForwardIterator abstractforwarditeratorxx)
  { if (abstractforwarditeratorxx == null) { return; }
   abstractforwarditerators.remove(abstractforwarditeratorxx);
  }

  public void killAbstractAbstractForwardIterator(AbstractForwardIterator abstractforwarditeratorxx)
  {
    if (abstractforwarditeratorxx instanceof PermutationIterator)
    { killPermutationIterator((PermutationIterator) abstractforwarditeratorxx); }
  }

  public void killAbstractAbstractForwardIterator(List _l)
  { for (int _i = 0; _i < _l.size(); _i++)
    { AbstractForwardIterator _e = (AbstractForwardIterator) _l.get(_i);
      killAbstractAbstractForwardIterator(_e);
    }
  }



  public static void main(String[] args)
  { LexicographicOrdering ll = new LexicographicOrdering(); 
    Vector v = new Vector(); 
    v.add("a"); v.add("b"); v.add("c"); 
    ll.setalphabet(v); 
    ll.setn(3); 

    List r = ll.increment(new Vector()); 
    System.out.println(r); 
    while (r.size() <= 3)
    { r = ll.increment(r);
      if (ll.noduplicates(r))
      { System.out.println(r); }  
    }
  /*   
    List r1 = ll.increment(r); 
    System.out.println(r1); 
    List r2 = ll.increment(r1); 
    System.out.println(r2); 
    List r3 = ll.increment(r2); 
    System.out.println(r3); 
    List r4 = ll.increment(r3); 
    System.out.println(r4); 
   
    List w = ll.increment(v); 
    System.out.println(w); 
    List u = ll.increment(w); 
    System.out.println(w); 
    List uu = ll.increment(u); 
    System.out.println(uu); 
    List vv = ll.increment(uu); 
    System.out.println(vv); */ 
  } 

   
}



