import java.util.List;
import java.util.Date;
import java.util.Map;
import java.util.HashMap;
import java.util.Vector;

import java.lang.*;
import java.lang.reflect.*;
import java.util.StringTokenizer;
import java.io.*;



class MathLib
  implements SystemTypes
{
  private static int ix = 0; // internal
  private static int iy = 0; // internal
  private static int iz = 0; // internal

  public MathLib()
  {
    this.ix = 0;
    this.iy = 0;
    this.iz = 0;

  }



  public String toString()
  { String _res_ = "(MathLib) ";
    _res_ = _res_ + ix + ",";
    _res_ = _res_ + iy + ",";
    _res_ = _res_ + iz;
    return _res_;
  }

  public static MathLib parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = Set.tokeniseCSV(_line);
    MathLib mathlibx = new MathLib();
    mathlibx.ix = Integer.parseInt((String) _line1vals.get(0));
    mathlibx.iy = Integer.parseInt((String) _line1vals.get(1));
    mathlibx.iz = Integer.parseInt((String) _line1vals.get(2));
    return mathlibx;
  }


  public void writeCSV(PrintWriter _out)
  { MathLib mathlibx = this;
    _out.print("" + mathlibx.ix);
    _out.print(" , ");
    _out.print("" + mathlibx.iy);
    _out.print(" , ");
    _out.print("" + mathlibx.iz);
    _out.println();
  }


  public static void setix(int ix_x) { ix = ix_x; }

public void localSetix(int ix_x) {   }


    public static void setAllix(List mathlibs,int val)
  { for (int i = 0; i < mathlibs.size(); i++)
    { MathLib mathlibx = (MathLib) mathlibs.get(i);
      Controller.inst().setix(mathlibx,val); } }


  public static void setiy(int iy_x) { iy = iy_x; }

public void localSetiy(int iy_x) {   }


    public static void setAlliy(List mathlibs,int val)
  { for (int i = 0; i < mathlibs.size(); i++)
    { MathLib mathlibx = (MathLib) mathlibs.get(i);
      Controller.inst().setiy(mathlibx,val); } }


  public static void setiz(int iz_x) { iz = iz_x; }

public void localSetiz(int iz_x) {   }


    public static void setAlliz(List mathlibs,int val)
  { for (int i = 0; i < mathlibs.size(); i++)
    { MathLib mathlibx = (MathLib) mathlibs.get(i);
      Controller.inst().setiz(mathlibx,val); } }


    public static int getix() { return ix; }

    public static List getAllix(List mathlibs)
  { List result = new Vector();
   if (mathlibs.size() > 0)
   { result.add(new Integer(MathLib.ix)); }
    return result; }

    public static List getAllOrderedix(List mathlibs)
  { List result = new Vector();
    for (int i = 0; i < mathlibs.size(); i++)
    { MathLib mathlibx = (MathLib) mathlibs.get(i);
      result.add(new Integer(mathlibx.getix())); } 
    return result; }

    public static int getiy() { return iy; }

    public static List getAlliy(List mathlibs)
  { List result = new Vector();
   if (mathlibs.size() > 0)
   { result.add(new Integer(MathLib.iy)); }
    return result; }

    public static List getAllOrderediy(List mathlibs)
  { List result = new Vector();
    for (int i = 0; i < mathlibs.size(); i++)
    { MathLib mathlibx = (MathLib) mathlibs.get(i);
      result.add(new Integer(mathlibx.getiy())); } 
    return result; }

    public static int getiz() { return iz; }

    public static List getAlliz(List mathlibs)
  { List result = new Vector();
   if (mathlibs.size() > 0)
   { result.add(new Integer(MathLib.iz)); }
    return result; }

    public static List getAllOrderediz(List mathlibs)
  { List result = new Vector();
    for (int i = 0; i < mathlibs.size(); i++)
    { MathLib mathlibx = (MathLib) mathlibs.get(i);
      result.add(new Integer(mathlibx.getiz())); } 
    return result; }

    public static double pi()
  {   double result = 0;
 
  result = 3.14159265;
    return result;
  }


    public static double e()
  {   double result = 0;
 
  result = Math.exp(1);
    return result;
  }


    public static void setSeeds(int x,int y,int z)
  { MathLib.setix(x);
    MathLib.setiy(y);
    MathLib.setiz(z);
  }

    public static double nrandom()
  {   double result = 0;
 
  ix = ( ix * 171 ) % 30269;
   iy = ( iy * 172 ) % 30307;
   iz = ( iz * 170 ) % 30323;
   result = ( ix / 30269.0 + iy / 30307.0 + iz / 30323.0 );
             return result;
  }


    public static double random()
  {   double result = 0;
 
  double r = MathLib.nrandom(); 
     result = ( r - ((int) Math.floor(r)) );
       return result;
  }



}


class NormalDist
  implements SystemTypes
{

  public NormalDist()
  {

  }



  public String toString()
  { String _res_ = "(NormalDist) ";
    return _res_;
  }

  public static NormalDist parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = Set.tokeniseCSV(_line);
    NormalDist normaldistx = new NormalDist();
    return normaldistx;
  }


  public void writeCSV(PrintWriter _out)
  { NormalDist normaldistx = this;
    _out.println();
  }


    public static double normal(double m,double sigma,double x)
  {   double result = 0;
 
  double disp = x - m; 
     double denom = Math.exp(( -0.5 * disp * disp / ( sigma * sigma ) )); 
     double num = sigma * Math.sqrt(( 2 * MathLib.pi() )); 
     result = denom / num;
             return result;
  }


    public static double cumulative(double m,double sigma,double x)
  {   double result = 0;
    if (x < m) { return result; } 
   
  double k = ( 1 / ( 1 + 0.2316419 * ( x - m ) ) ); 
     double poly = ( 0.31938153 * k ) + ( -0.356563782 * k * k ) + ( 1.781477937 * k * k * k ) + ( -1.821255978 * k * k * k * k ) + ( 1.330274429 * k * k * k * k * k ); 
     result = 1 - NormalDist.normal(m,sigma,x) * poly;
          return result;
  }


    public static double cdf(double x)
  {   double result = 0;
 
  if (x >= 0) 
  {   result = NormalDist.cumulative(0,1,x);
 
  }  else
      if (x < 0) 
  {   result = 1 - NormalDist.cumulative(0,1,-x);
 
  }       return result;
  }


    public static double sample()
  {   double result = 0;
 
  double r1 = MathLib.nrandom(); 
     double r2 = MathLib.nrandom(); 
     double r3 = MathLib.nrandom(); 
     double r4 = MathLib.nrandom(); 
     result = ( r1 + r2 + r3 + r4 ) - 6;
                return result;
  }



}


class DifferentialEvolution
  implements SystemTypes
{
  private int populationSize = 0; // internal
  private int maxGenerations = 0; // internal
  private int generations = 0; // internal
  private List population = new Vector(); // of DEIndividual

  public DifferentialEvolution()
  {
    this.populationSize = 0;
    this.maxGenerations = 0;
    this.generations = 0;

  }



  public String toString()
  { String _res_ = "(DifferentialEvolution) ";
    _res_ = _res_ + populationSize + ",";
    _res_ = _res_ + maxGenerations + ",";
    _res_ = _res_ + generations;
    return _res_;
  }

  public static DifferentialEvolution parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = Set.tokeniseCSV(_line);
    DifferentialEvolution differentialevolutionx = new DifferentialEvolution();
    differentialevolutionx.populationSize = Integer.parseInt((String) _line1vals.get(0));
    differentialevolutionx.maxGenerations = Integer.parseInt((String) _line1vals.get(1));
    differentialevolutionx.generations = Integer.parseInt((String) _line1vals.get(2));
    return differentialevolutionx;
  }


  public void writeCSV(PrintWriter _out)
  { DifferentialEvolution differentialevolutionx = this;
    _out.print("" + differentialevolutionx.populationSize);
    _out.print(" , ");
    _out.print("" + differentialevolutionx.maxGenerations);
    _out.print(" , ");
    _out.print("" + differentialevolutionx.generations);
    _out.println();
  }


  public void setpopulationSize(int populationSize_x) { populationSize = populationSize_x;  }


    public static void setAllpopulationSize(List differentialevolutions,int val)
  { for (int i = 0; i < differentialevolutions.size(); i++)
    { DifferentialEvolution differentialevolutionx = (DifferentialEvolution) differentialevolutions.get(i);
      Controller.inst().setpopulationSize(differentialevolutionx,val); } }


  public void setmaxGenerations(int maxGenerations_x) { maxGenerations = maxGenerations_x;  }


    public static void setAllmaxGenerations(List differentialevolutions,int val)
  { for (int i = 0; i < differentialevolutions.size(); i++)
    { DifferentialEvolution differentialevolutionx = (DifferentialEvolution) differentialevolutions.get(i);
      Controller.inst().setmaxGenerations(differentialevolutionx,val); } }


  public void setgenerations(int generations_x) { generations = generations_x;  }


    public static void setAllgenerations(List differentialevolutions,int val)
  { for (int i = 0; i < differentialevolutions.size(); i++)
    { DifferentialEvolution differentialevolutionx = (DifferentialEvolution) differentialevolutions.get(i);
      Controller.inst().setgenerations(differentialevolutionx,val); } }


  public void setpopulation(List population_xx) { population = population_xx;
    }
 
  public void setpopulation(int ind_x, DEIndividual population_xx) { if (ind_x >= 0 && ind_x < population.size()) { population.set(ind_x, population_xx); } }

 public void addpopulation(DEIndividual population_xx) { population.add(population_xx);
    }
 
  public void removepopulation(DEIndividual population_xx) { Vector _removedpopulationpopulation_xx = new Vector();
  _removedpopulationpopulation_xx.add(population_xx);
  population.removeAll(_removedpopulationpopulation_xx);
    }

  public static void setAllpopulation(List differentialevolutions, List _val)
  { for (int _i = 0; _i < differentialevolutions.size(); _i++)
    { DifferentialEvolution differentialevolutionx = (DifferentialEvolution) differentialevolutions.get(_i);
      Controller.inst().setpopulation(differentialevolutionx, _val); } }

  public static void setAllpopulation(List differentialevolutions, int _ind,DEIndividual _val)
  { for (int _i = 0; _i < differentialevolutions.size(); _i++)
    { DifferentialEvolution differentialevolutionx = (DifferentialEvolution) differentialevolutions.get(_i);
      Controller.inst().setpopulation(differentialevolutionx,_ind,_val); } }

  public static void addAllpopulation(List differentialevolutions, DEIndividual _val)
  { for (int _i = 0; _i < differentialevolutions.size(); _i++)
    { DifferentialEvolution differentialevolutionx = (DifferentialEvolution) differentialevolutions.get(_i);
      Controller.inst().addpopulation(differentialevolutionx,  _val); } }


  public static void removeAllpopulation(List differentialevolutions,DEIndividual _val)
  { for (int _i = 0; _i < differentialevolutions.size(); _i++)
    { DifferentialEvolution differentialevolutionx = (DifferentialEvolution) differentialevolutions.get(_i);
      Controller.inst().removepopulation(differentialevolutionx, _val); } }


  public static void unionAllpopulation(List differentialevolutions, List _val)
  { for (int _i = 0; _i < differentialevolutions.size(); _i++)
    { DifferentialEvolution differentialevolutionx = (DifferentialEvolution) differentialevolutions.get(_i);
      Controller.inst().unionpopulation(differentialevolutionx, _val); } }


  public static void subtractAllpopulation(List differentialevolutions,  List _val)
  { for (int _i = 0; _i < differentialevolutions.size(); _i++)
    { DifferentialEvolution differentialevolutionx = (DifferentialEvolution) differentialevolutions.get(_i);
      Controller.inst().subtractpopulation(differentialevolutionx,  _val); } }


    public int getpopulationSize() { return populationSize; }

    public static List getAllpopulationSize(List differentialevolutions)
  { List result = new Vector();
    for (int i = 0; i < differentialevolutions.size(); i++)
    { DifferentialEvolution differentialevolutionx = (DifferentialEvolution) differentialevolutions.get(i);
      if (result.contains(new Integer(differentialevolutionx.getpopulationSize()))) { }
      else { result.add(new Integer(differentialevolutionx.getpopulationSize())); } }
    return result; }

    public static List getAllOrderedpopulationSize(List differentialevolutions)
  { List result = new Vector();
    for (int i = 0; i < differentialevolutions.size(); i++)
    { DifferentialEvolution differentialevolutionx = (DifferentialEvolution) differentialevolutions.get(i);
      result.add(new Integer(differentialevolutionx.getpopulationSize())); } 
    return result; }

    public int getmaxGenerations() { return maxGenerations; }

    public static List getAllmaxGenerations(List differentialevolutions)
  { List result = new Vector();
    for (int i = 0; i < differentialevolutions.size(); i++)
    { DifferentialEvolution differentialevolutionx = (DifferentialEvolution) differentialevolutions.get(i);
      if (result.contains(new Integer(differentialevolutionx.getmaxGenerations()))) { }
      else { result.add(new Integer(differentialevolutionx.getmaxGenerations())); } }
    return result; }

    public static List getAllOrderedmaxGenerations(List differentialevolutions)
  { List result = new Vector();
    for (int i = 0; i < differentialevolutions.size(); i++)
    { DifferentialEvolution differentialevolutionx = (DifferentialEvolution) differentialevolutions.get(i);
      result.add(new Integer(differentialevolutionx.getmaxGenerations())); } 
    return result; }

    public int getgenerations() { return generations; }

    public static List getAllgenerations(List differentialevolutions)
  { List result = new Vector();
    for (int i = 0; i < differentialevolutions.size(); i++)
    { DifferentialEvolution differentialevolutionx = (DifferentialEvolution) differentialevolutions.get(i);
      if (result.contains(new Integer(differentialevolutionx.getgenerations()))) { }
      else { result.add(new Integer(differentialevolutionx.getgenerations())); } }
    return result; }

    public static List getAllOrderedgenerations(List differentialevolutions)
  { List result = new Vector();
    for (int i = 0; i < differentialevolutions.size(); i++)
    { DifferentialEvolution differentialevolutionx = (DifferentialEvolution) differentialevolutions.get(i);
      result.add(new Integer(differentialevolutionx.getgenerations())); } 
    return result; }

  public List getpopulation() { return (Vector) ((Vector) population).clone(); }

  public static List getAllpopulation(List differentialevolutions)
  { List result = new Vector();
    for (int _i = 0; _i < differentialevolutions.size(); _i++)
    { DifferentialEvolution differentialevolutionx = (DifferentialEvolution) differentialevolutions.get(_i);
      result = Set.union(result, differentialevolutionx.getpopulation()); }
    return result; }

  public static List getAllOrderedpopulation(List differentialevolutions)
  { List result = new Vector();
    for (int _i = 0; _i < differentialevolutions.size(); _i++)
    { DifferentialEvolution differentialevolutionx = (DifferentialEvolution) differentialevolutions.get(_i);
      result.addAll(differentialevolutionx.getpopulation()); }
    return result; }

    public DEIndividual getFittest()
  {   DEIndividual result = null;
    if (population.size() <= 0) { return result; } 
   
  result = ((DEIndividual) Set.any(Set.minimalElements(population, Set.collect_0(population))));
    return result;
  }


    public void initialise2()
  {     List _int_list5 = new Vector();
    _int_list5.addAll(Set.integerSubrange(1,this.getpopulationSize()));
    for (int _ind6 = 0; _ind6 < _int_list5.size(); _ind6++)
    { int i = ((Integer) _int_list5.get(_ind6)).intValue();
      DEIndividual d = new DEIndividual();
    Controller.inst().addDEIndividual(d);
    Controller.inst().addpopulation(this,d);
    Controller.inst().init(d,i,( 3.0 + i / 200.0 ));
    }

  }

    public void evolvepopulation1()
  {     int pre_generations7 = generations;
    List pre_population8 = new Vector();
    pre_population8.addAll(population);
  if (pre_generations7 < this.getmaxGenerations()) 
  { Controller.inst().setpopulation(this,Set.collect_1(pre_population8));
    Controller.inst().setgenerations(this,pre_generations7 + 1);}
  }

    public void evolvepopulation3()
  {   System.out.println("" + this.getFittest());

  }


}


class DEIndividual
  implements SystemTypes
{
  private double f = 0; // internal
  private List traits = new Vector(); // of DETrait

  public DEIndividual()
  {
    this.f = 0;

  }



  public static DEIndividual parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = Set.tokeniseCSV(_line);
    DEIndividual deindividualx = new DEIndividual();
    deindividualx.f = Double.parseDouble((String) _line1vals.get(0));
    return deindividualx;
  }


  public void writeCSV(PrintWriter _out)
  { DEIndividual deindividualx = this;
    _out.print("" + deindividualx.f);
    _out.println();
  }


  public void setf(double f_x) { f = f_x;  }


    public static void setAllf(List deindividuals,double val)
  { for (int i = 0; i < deindividuals.size(); i++)
    { DEIndividual deindividualx = (DEIndividual) deindividuals.get(i);
      Controller.inst().setf(deindividualx,val); } }


  public void settraits(List traits_xx) { traits = traits_xx;
    }
 
  public void settraits(int ind_x, DETrait traits_xx) { if (ind_x >= 0 && ind_x < traits.size()) { traits.set(ind_x, traits_xx); } }

 public void addtraits(DETrait traits_xx) { traits.add(traits_xx);
    }
 
  public void removetraits(DETrait traits_xx) { Vector _removedtraitstraits_xx = new Vector();
  _removedtraitstraits_xx.add(traits_xx);
  traits.removeAll(_removedtraitstraits_xx);
    }

  public static void setAlltraits(List deindividuals, List _val)
  { for (int _i = 0; _i < deindividuals.size(); _i++)
    { DEIndividual deindividualx = (DEIndividual) deindividuals.get(_i);
      Controller.inst().settraits(deindividualx, _val); } }

  public static void setAlltraits(List deindividuals, int _ind,DETrait _val)
  { for (int _i = 0; _i < deindividuals.size(); _i++)
    { DEIndividual deindividualx = (DEIndividual) deindividuals.get(_i);
      Controller.inst().settraits(deindividualx,_ind,_val); } }

  public static void addAlltraits(List deindividuals, DETrait _val)
  { for (int _i = 0; _i < deindividuals.size(); _i++)
    { DEIndividual deindividualx = (DEIndividual) deindividuals.get(_i);
      Controller.inst().addtraits(deindividualx,  _val); } }


  public static void removeAlltraits(List deindividuals,DETrait _val)
  { for (int _i = 0; _i < deindividuals.size(); _i++)
    { DEIndividual deindividualx = (DEIndividual) deindividuals.get(_i);
      Controller.inst().removetraits(deindividualx, _val); } }


  public static void unionAlltraits(List deindividuals, List _val)
  { for (int _i = 0; _i < deindividuals.size(); _i++)
    { DEIndividual deindividualx = (DEIndividual) deindividuals.get(_i);
      Controller.inst().uniontraits(deindividualx, _val); } }


  public static void subtractAlltraits(List deindividuals,  List _val)
  { for (int _i = 0; _i < deindividuals.size(); _i++)
    { DEIndividual deindividualx = (DEIndividual) deindividuals.get(_i);
      Controller.inst().subtracttraits(deindividualx,  _val); } }


    public double getf() { return f; }

    public static List getAllf(List deindividuals)
  { List result = new Vector();
    for (int i = 0; i < deindividuals.size(); i++)
    { DEIndividual deindividualx = (DEIndividual) deindividuals.get(i);
      if (result.contains(new Double(deindividualx.getf()))) { }
      else { result.add(new Double(deindividualx.getf())); } }
    return result; }

    public static List getAllOrderedf(List deindividuals)
  { List result = new Vector();
    for (int i = 0; i < deindividuals.size(); i++)
    { DEIndividual deindividualx = (DEIndividual) deindividuals.get(i);
      result.add(new Double(deindividualx.getf())); } 
    return result; }

  public List gettraits() { return (Vector) ((Vector) traits).clone(); }

  public static List getAlltraits(List deindividuals)
  { List result = new Vector();
    for (int _i = 0; _i < deindividuals.size(); _i++)
    { DEIndividual deindividualx = (DEIndividual) deindividuals.get(_i);
      result = Set.union(result, deindividualx.gettraits()); }
    return result; }

  public static List getAllOrderedtraits(List deindividuals)
  { List result = new Vector();
    for (int _i = 0; _i < deindividuals.size(); _i++)
    { DEIndividual deindividualx = (DEIndividual) deindividuals.get(_i);
      result.addAll(deindividualx.gettraits()); }
    return result; }

    public void init(double x,double y)
  { DETrait de1 = new DETrait();
    Controller.inst().addDETrait(de1);
    Controller.inst().setattribute(de1,"beta3");
    Controller.inst().setvalue(de1,x);
    Controller.inst().addtraits(this,de1);
    DETrait de2 = new DETrait();
    Controller.inst().addDETrait(de2);
    Controller.inst().setattribute(de2,"lambda1");
    Controller.inst().setvalue(de2,y);
    Controller.inst().addtraits(this,de2);
  }

    public DEIndividual mutate()
  {   DEIndividual result = null;
DEIndividual newg = new DEIndividual();
    Controller.inst().addDEIndividual(newg);
    Controller.inst().settraits(newg,Set.collect_2(this.gettraits(),f));
    Controller.inst().setf(newg,newg.fitness());
      if (newg.getf() <= this.getf()) 
  { result = newg; System.out.println("Mutated " + getf() + " to " + newg.getf()); }
      else if (newg.getf() > this.getf()) 
  { result = this;
    }
  return result;

  }

    public String toString()
  {   String result = "";
 
  result = Set.sumString(Set.collect_3(traits));
    return result + " Fitness = " + f;
  }


    public double fitness()
  {   double result = 0;
 
    double x = ((DETrait) traits.get(1)).getvalue();
    double xx = Math.abs(x); 
    if (xx == 0.0)
    { return 1; }
  result = Math.abs(( Math.pow(xx,xx) - 100 ));
    return result;
  }


    public void initialise3()
  { Controller.inst().setf(this,this.fitness());
  }

    public void evolvepopulation2()
  { Controller.inst().setf(this,this.fitness());
  }


}


class DETrait
  implements SystemTypes
{
  private String attribute = ""; // internal
  private double value = 0; // internal

  public DETrait()
  {
    this.attribute = "";
    this.value = 0;

  }



  public String toString()
  { String _res_ = "(DETrait) ";
    _res_ = _res_ + attribute + ",";
    _res_ = _res_ + value;
    return _res_;
  }

  public static DETrait parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = Set.tokeniseCSV(_line);
    DETrait detraitx = new DETrait();
    detraitx.attribute = (String) _line1vals.get(0);
    detraitx.value = Double.parseDouble((String) _line1vals.get(1));
    return detraitx;
  }


  public void writeCSV(PrintWriter _out)
  { DETrait detraitx = this;
    _out.print("" + detraitx.attribute);
    _out.print(" , ");
    _out.print("" + detraitx.value);
    _out.println();
  }


  public void setattribute(String attribute_x) { attribute = attribute_x;  }


    public static void setAllattribute(List detraits,String val)
  { for (int i = 0; i < detraits.size(); i++)
    { DETrait detraitx = (DETrait) detraits.get(i);
      Controller.inst().setattribute(detraitx,val); } }


  public void setvalue(double value_x) { value = value_x;  }


    public static void setAllvalue(List detraits,double val)
  { for (int i = 0; i < detraits.size(); i++)
    { DETrait detraitx = (DETrait) detraits.get(i);
      Controller.inst().setvalue(detraitx,val); } }


    public String getattribute() { return attribute; }

    public static List getAllattribute(List detraits)
  { List result = new Vector();
    for (int i = 0; i < detraits.size(); i++)
    { DETrait detraitx = (DETrait) detraits.get(i);
      if (result.contains(detraitx.getattribute())) { }
      else { result.add(detraitx.getattribute()); } }
    return result; }

    public static List getAllOrderedattribute(List detraits)
  { List result = new Vector();
    for (int i = 0; i < detraits.size(); i++)
    { DETrait detraitx = (DETrait) detraits.get(i);
      result.add(detraitx.getattribute()); } 
    return result; }

    public double getvalue() { return value; }

    public static List getAllvalue(List detraits)
  { List result = new Vector();
    for (int i = 0; i < detraits.size(); i++)
    { DETrait detraitx = (DETrait) detraits.get(i);
      if (result.contains(new Double(detraitx.getvalue()))) { }
      else { result.add(new Double(detraitx.getvalue())); } }
    return result; }

    public static List getAllOrderedvalue(List detraits)
  { List result = new Vector();
    for (int i = 0; i < detraits.size(); i++)
    { DETrait detraitx = (DETrait) detraits.get(i);
      result.add(new Double(detraitx.getvalue())); } 
    return result; }

    public DETrait mutate(double f)
  {   DETrait result = null;
DETrait t = new DETrait();
    Controller.inst().addDETrait(t);
    Controller.inst().setattribute(t,this.getattribute());
    Controller.inst().setvalue(t,( NormalDist.sample()*f ) + this.getvalue());
    result = t;
  return result;

  }


}


class NSDE
  implements SystemTypes
{

  public NSDE()
  {

  }



  public String toString()
  { String _res_ = "(NSDE) ";
    return _res_;
  }

  public static NSDE parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = Set.tokeniseCSV(_line);
    NSDE nsdex = new NSDE();
    return nsdex;
  }


  public void writeCSV(PrintWriter _out)
  { NSDE nsdex = this;
    _out.println();
  }


    public static double nelsonseigal(double t,double v1,double v2,double v3,double lambda)
  {   double result = 0;
 
  double tscaled = t / lambda; 
     double exptscaled = Math.exp(-tscaled); 
     double expratio = ( 1 - exptscaled ) / tscaled; 
     result = v1 + v2 * expratio + v3 * ( expratio - exptscaled );
             return result;
  }


    public static double ns(double t,double v1,double v2,double v3,double lambda)
  {   double result = 0;
 
  if (t == 0) 
  {   result = v1 + v2;
 
  }  else
      if (t > 0) 
  {   result = NSDE.nelsonseigal(t,v1,v2,v3,lambda);
 
  }       return result;
  }


    public static double beta3(double y,double t,double b1,double b2,double lambda)
  {   double result = 0;
 
  double tscaled = t / lambda; 
     double exptscaled = Math.exp(-tscaled); 
     double expratio = ( 1 - exptscaled ) / tscaled; 
     double numerator = y - b1 - b2 * expratio; 
     double denom = expratio - exptscaled; 
     result = numerator / denom;
                   return result;
  }



}


class Initialise
  implements SystemTypes
{

  public Initialise()
  {

  }



  public String toString()
  { String _res_ = "(Initialise) ";
    return _res_;
  }

  public static Initialise parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = Set.tokeniseCSV(_line);
    Initialise initialisex = new Initialise();
    return initialisex;
  }


  public void writeCSV(PrintWriter _out)
  { Initialise initialisex = this;
    _out.println();
  }


  


}


class EvolvePopulation
  implements SystemTypes
{

  public EvolvePopulation()
  {

  }



  public String toString()
  { String _res_ = "(EvolvePopulation) ";
    return _res_;
  }

  public static EvolvePopulation parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = Set.tokeniseCSV(_line);
    EvolvePopulation evolvepopulationx = new EvolvePopulation();
    return evolvepopulationx;
  }


  public void writeCSV(PrintWriter _out)
  { EvolvePopulation evolvepopulationx = this;
    _out.println();
  }


  


}



public class Controller implements SystemTypes, ControllerInterface
{
  Vector mathlibs = new Vector();
  Vector normaldists = new Vector();
  Vector differentialevolutions = new Vector();
  Vector deindividuals = new Vector();
  Vector detraits = new Vector();
  Vector nsdes = new Vector();
  Vector initialises = new Vector();
  Vector evolvepopulations = new Vector();
  private static Controller uniqueInstance; 


  private Controller() { } 


  public static Controller inst() 
    { if (uniqueInstance == null) 
    { uniqueInstance = new Controller(); }
    return uniqueInstance; } 


  public static void loadModel(String file)
  {
    try
    { BufferedReader br = null;
      File f = new File(file);
      try 
      { br = new BufferedReader(new FileReader(f)); }
      catch (Exception ex) 
      { System.err.println("No file: " + file); return; }
      Class cont = Class.forName("Controller");
      java.util.Map objectmap = new java.util.HashMap();
      while (true)
      { String line1;
        try { line1 = br.readLine(); }
        catch (Exception e)
        { return; }
        if (line1 == null)
        { return; }
        line1 = line1.trim();

        if (line1.length() == 0) { continue; }
        if (line1.startsWith("//")) { continue; }
        String left;
        String op;
        String right;
        if (line1.charAt(line1.length() - 1) == '"')
        { int eqind = line1.indexOf("="); 
          if (eqind == -1) { continue; }
          else 
          { left = line1.substring(0,eqind-1).trim();
            op = "="; 
            right = line1.substring(eqind+1,line1.length()).trim();
          }
        }
        else
        { StringTokenizer st1 = new StringTokenizer(line1);
          Vector vals1 = new Vector();
          while (st1.hasMoreTokens())
          { String val1 = st1.nextToken();
            vals1.add(val1);
          }
          if (vals1.size() < 3)
          { continue; }
          left = (String) vals1.get(0);
          op = (String) vals1.get(1);
          right = (String) vals1.get(2);
        }
        if (":".equals(op))
        { int i2 = right.indexOf(".");
          if (i2 == -1)
          { Class cl;
            try { cl = Class.forName("" + right); }
            catch (Exception _x) { System.err.println("No entity: " + right); continue; }
            Object xinst = cl.newInstance();
            objectmap.put(left,xinst);
            Class[] cargs = new Class[] { cl };
            Method addC = null;
            try { addC = cont.getMethod("add" + right,cargs); }
            catch (Exception _xx) { System.err.println("No entity: " + right); continue; }
            if (addC == null) { continue; }
            Object[] args = new Object[] { xinst };
            addC.invoke(Controller.inst(),args);
          }
          else
          { String obj = right.substring(0,i2);
            String role = right.substring(i2+1,right.length());
            Object objinst = objectmap.get(obj); 
            if (objinst == null) 
            { continue; }
            Object val = objectmap.get(left);
            if (val == null) 
            { continue; }
            Class objC = objinst.getClass();
            Class typeclass = val.getClass(); 
            Object[] args = new Object[] { val }; 
            Class[] settypes = new Class[] { typeclass };
            Method addrole = Controller.findMethod(objC,"add" + role);
            if (addrole != null) 
            { addrole.invoke(objinst, args); }
            else { System.err.println("Error: cannot add to " + role); }
          }
        }
        else if ("=".equals(op))
        { int i1 = left.indexOf(".");
          if (i1 == -1) 
          { continue; }
          String obj = left.substring(0,i1);
          String att = left.substring(i1+1,left.length());
          Object objinst = objectmap.get(obj); 
          if (objinst == null) 
          { System.err.println("No object: " + obj); continue; }
          Class objC = objinst.getClass();
          Class typeclass; 
          Object val; 
          if (right.charAt(0) == '"' &&
              right.charAt(right.length() - 1) == '"')
          { typeclass = String.class;
            val = right.substring(1,right.length() - 1);
          } 
          else if ("true".equals(right) || "false".equals(right))
          { typeclass = boolean.class;
            if ("true".equals(right))
            { val = new Boolean(true); }
            else
            { val = new Boolean(false); }
          }
          else 
          { val = objectmap.get(right);
            if (val != null)
            { typeclass = val.getClass(); }
            else 
            { int i;
              long l; 
              double d;
              try 
              { i = Integer.parseInt(right);
                typeclass = int.class;
                val = new Integer(i); 
              }
              catch (Exception ee)
              { try 
                { l = Long.parseLong(right);
                  typeclass = long.class;
                  val = new Long(l); 
                }
                catch (Exception eee)
                { try
                  { d = Double.parseDouble(right);
                    typeclass = double.class;
                    val = new Double(d);
                  }
                  catch (Exception ff)
                  { continue; }
                }
              }
            }
          }
          Object[] args = new Object[] { val }; 
          Class[] settypes = new Class[] { typeclass };
          Method setatt = Controller.findMethod(objC,"set" + att);
          if (setatt != null) 
          { setatt.invoke(objinst, args); }
          else { System.err.println("No attribute: " + objC.getName() + "::" + att); }
        }
      }
    } catch (Exception e) { }
  }

  public static Method findMethod(Class c, String name)
  { Method[] mets = c.getMethods(); 
    for (int i = 0; i < mets.length; i++)
    { Method m = mets[i];
      if (m.getName().equals(name))
      { return m; }
    } 
    return null;
  }


  public static void loadCSVModel()
  { boolean __eof = false;
    String __s = "";
    Controller __cont = Controller.inst();
    BufferedReader __br = null;
    try
    { File _mathlib = new File("MathLib.csv");
      __br = new BufferedReader(new FileReader(_mathlib));
      __eof = false;
      while (!__eof)
      { try { __s = __br.readLine(); }
        catch (IOException __e)
        { System.out.println("Reading failed.");
          return;
        }
        if (__s == null)
        { __eof = true; }
        else
        { MathLib mathlibx = MathLib.parseCSV(__s.trim());
          if (mathlibx != null)
          { __cont.addMathLib(mathlibx); }
        }
      }
    }
    catch(Exception __e) { }
    try
    { File _normaldist = new File("NormalDist.csv");
      __br = new BufferedReader(new FileReader(_normaldist));
      __eof = false;
      while (!__eof)
      { try { __s = __br.readLine(); }
        catch (IOException __e)
        { System.out.println("Reading failed.");
          return;
        }
        if (__s == null)
        { __eof = true; }
        else
        { NormalDist normaldistx = NormalDist.parseCSV(__s.trim());
          if (normaldistx != null)
          { __cont.addNormalDist(normaldistx); }
        }
      }
    }
    catch(Exception __e) { }
    try
    { File _differentialevolution = new File("DifferentialEvolution.csv");
      __br = new BufferedReader(new FileReader(_differentialevolution));
      __eof = false;
      while (!__eof)
      { try { __s = __br.readLine(); }
        catch (IOException __e)
        { System.out.println("Reading failed.");
          return;
        }
        if (__s == null)
        { __eof = true; }
        else
        { DifferentialEvolution differentialevolutionx = DifferentialEvolution.parseCSV(__s.trim());
          if (differentialevolutionx != null)
          { __cont.addDifferentialEvolution(differentialevolutionx); }
        }
      }
    }
    catch(Exception __e) { }
    try
    { File _deindividual = new File("DEIndividual.csv");
      __br = new BufferedReader(new FileReader(_deindividual));
      __eof = false;
      while (!__eof)
      { try { __s = __br.readLine(); }
        catch (IOException __e)
        { System.out.println("Reading failed.");
          return;
        }
        if (__s == null)
        { __eof = true; }
        else
        { DEIndividual deindividualx = DEIndividual.parseCSV(__s.trim());
          if (deindividualx != null)
          { __cont.addDEIndividual(deindividualx); }
        }
      }
    }
    catch(Exception __e) { }
    try
    { File _detrait = new File("DETrait.csv");
      __br = new BufferedReader(new FileReader(_detrait));
      __eof = false;
      while (!__eof)
      { try { __s = __br.readLine(); }
        catch (IOException __e)
        { System.out.println("Reading failed.");
          return;
        }
        if (__s == null)
        { __eof = true; }
        else
        { DETrait detraitx = DETrait.parseCSV(__s.trim());
          if (detraitx != null)
          { __cont.addDETrait(detraitx); }
        }
      }
    }
    catch(Exception __e) { }
    try
    { File _nsde = new File("NSDE.csv");
      __br = new BufferedReader(new FileReader(_nsde));
      __eof = false;
      while (!__eof)
      { try { __s = __br.readLine(); }
        catch (IOException __e)
        { System.out.println("Reading failed.");
          return;
        }
        if (__s == null)
        { __eof = true; }
        else
        { NSDE nsdex = NSDE.parseCSV(__s.trim());
          if (nsdex != null)
          { __cont.addNSDE(nsdex); }
        }
      }
    }
    catch(Exception __e) { }
    try
    { File _initialise = new File("Initialise.csv");
      __br = new BufferedReader(new FileReader(_initialise));
      __eof = false;
      while (!__eof)
      { try { __s = __br.readLine(); }
        catch (IOException __e)
        { System.out.println("Reading failed.");
          return;
        }
        if (__s == null)
        { __eof = true; }
        else
        { Initialise initialisex = Initialise.parseCSV(__s.trim());
          if (initialisex != null)
          { __cont.addInitialise(initialisex); }
        }
      }
    }
    catch(Exception __e) { }
    try
    { File _evolvepopulation = new File("EvolvePopulation.csv");
      __br = new BufferedReader(new FileReader(_evolvepopulation));
      __eof = false;
      while (!__eof)
      { try { __s = __br.readLine(); }
        catch (IOException __e)
        { System.out.println("Reading failed.");
          return;
        }
        if (__s == null)
        { __eof = true; }
        else
        { EvolvePopulation evolvepopulationx = EvolvePopulation.parseCSV(__s.trim());
          if (evolvepopulationx != null)
          { __cont.addEvolvePopulation(evolvepopulationx); }
        }
      }
    }
    catch(Exception __e) { }
  }


  public void checkCompleteness()
  {   }


  public void saveModel(String file)
  { File outfile = new File(file); 
    PrintWriter out; 
    try { out = new PrintWriter(new BufferedWriter(new FileWriter(outfile))); }
    catch (Exception e) { return; } 
  for (int _i = 0; _i < mathlibs.size(); _i++)
  { MathLib mathlibx_ = (MathLib) mathlibs.get(_i);
    out.println("mathlibx_" + _i + " : MathLib");
    out.println("mathlibx_" + _i + ".ix = " + mathlibx_.getix());
    out.println("mathlibx_" + _i + ".iy = " + mathlibx_.getiy());
    out.println("mathlibx_" + _i + ".iz = " + mathlibx_.getiz());
  }

  for (int _i = 0; _i < normaldists.size(); _i++)
  { NormalDist normaldistx_ = (NormalDist) normaldists.get(_i);
    out.println("normaldistx_" + _i + " : NormalDist");
  }

  for (int _i = 0; _i < differentialevolutions.size(); _i++)
  { DifferentialEvolution differentialevolutionx_ = (DifferentialEvolution) differentialevolutions.get(_i);
    out.println("differentialevolutionx_" + _i + " : DifferentialEvolution");
    out.println("differentialevolutionx_" + _i + ".populationSize = " + differentialevolutionx_.getpopulationSize());
    out.println("differentialevolutionx_" + _i + ".maxGenerations = " + differentialevolutionx_.getmaxGenerations());
    out.println("differentialevolutionx_" + _i + ".generations = " + differentialevolutionx_.getgenerations());
  }

  for (int _i = 0; _i < deindividuals.size(); _i++)
  { DEIndividual deindividualx_ = (DEIndividual) deindividuals.get(_i);
    out.println("deindividualx_" + _i + " : DEIndividual");
    out.println("deindividualx_" + _i + ".f = " + deindividualx_.getf());
  }

  for (int _i = 0; _i < detraits.size(); _i++)
  { DETrait detraitx_ = (DETrait) detraits.get(_i);
    out.println("detraitx_" + _i + " : DETrait");
    out.println("detraitx_" + _i + ".attribute = \"" + detraitx_.getattribute() + "\"");
    out.println("detraitx_" + _i + ".value = " + detraitx_.getvalue());
  }

  for (int _i = 0; _i < nsdes.size(); _i++)
  { NSDE nsdex_ = (NSDE) nsdes.get(_i);
    out.println("nsdex_" + _i + " : NSDE");
  }

  for (int _i = 0; _i < initialises.size(); _i++)
  { Initialise initialisex_ = (Initialise) initialises.get(_i);
    out.println("initialisex_" + _i + " : Initialise");
  }

  for (int _i = 0; _i < evolvepopulations.size(); _i++)
  { EvolvePopulation evolvepopulationx_ = (EvolvePopulation) evolvepopulations.get(_i);
    out.println("evolvepopulationx_" + _i + " : EvolvePopulation");
  }

  for (int _i = 0; _i < differentialevolutions.size(); _i++)
  { DifferentialEvolution differentialevolutionx_ = (DifferentialEvolution) differentialevolutions.get(_i);
    List differentialevolution_population_DEIndividual = differentialevolutionx_.getpopulation();
    for (int _j = 0; _j < differentialevolution_population_DEIndividual.size(); _j++)
    { out.println("deindividualx_" + deindividuals.indexOf(differentialevolution_population_DEIndividual.get(_j)) + " : differentialevolutionx_" + _i + ".population");
    }
  }
  for (int _i = 0; _i < deindividuals.size(); _i++)
  { DEIndividual deindividualx_ = (DEIndividual) deindividuals.get(_i);
    List deindividual_traits_DETrait = deindividualx_.gettraits();
    for (int _j = 0; _j < deindividual_traits_DETrait.size(); _j++)
    { out.println("detraitx_" + detraits.indexOf(deindividual_traits_DETrait.get(_j)) + " : deindividualx_" + _i + ".traits");
    }
  }
    out.close(); 
  }


  public static void loadXSI()
  { boolean __eof = false;
    String __s = "";
    String xmlstring = "";
    BufferedReader __br = null;
    try
    { File _classmodel = new File("in.xmi");
      __br = new BufferedReader(new FileReader(_classmodel));
      __eof = false;
      while (!__eof)
      { try { __s = __br.readLine(); }
        catch (IOException __e)
        { System.out.println("Reading failed.");
          return;
        }
        if (__s == null)
        { __eof = true; }
        else
        { xmlstring = xmlstring + __s; }
      } 
      __br.close();
    } 
    catch (Exception _x) { }
    Vector res = convertXsiToVector(xmlstring);
    File outfile = new File("_in.txt");
    PrintWriter out; 
    try { out = new PrintWriter(new BufferedWriter(new FileWriter(outfile))); }
    catch (Exception e) { return; } 
    for (int i = 0; i < res.size(); i++)
    { String r = (String) res.get(i); 
      out.println(r);
    } 
    out.close();
    loadModel("_in.txt");
  }

  public static Vector convertXsiToVector(String xmlstring)
  { Vector res = new Vector();
    XMLParser comp = new XMLParser();
    comp.nospacelexicalanalysisxml(xmlstring);
    XMLNode xml = comp.parseXML();
    if (xml == null) { return res; } 
    java.util.Map instancemap = new java.util.HashMap(); // String --> Vector
    java.util.Map entmap = new java.util.HashMap();       // String --> String
    Vector entcodes = new Vector(); 
    java.util.Map allattsmap = new java.util.HashMap(); // String --> Vector
    java.util.Map stringattsmap = new java.util.HashMap(); // String --> Vector
    java.util.Map onerolesmap = new java.util.HashMap(); // String --> Vector
    java.util.Map actualtype = new java.util.HashMap(); // XMLNode --> String
    Vector eallatts = new Vector();
    instancemap.put("mathlibs", new Vector()); 
    instancemap.put("mathlib",new Vector()); 
    entcodes.add("mathlibs");
    entcodes.add("mathlib");
    entmap.put("mathlibs","MathLib");
    entmap.put("mathlib","MathLib");
    eallatts = new Vector();
    eallatts.add("ix");
    eallatts.add("iy");
    eallatts.add("iz");
    allattsmap.put("MathLib", eallatts);
    eallatts = new Vector();
    stringattsmap.put("MathLib", eallatts);
    eallatts = new Vector();
    onerolesmap.put("MathLib", eallatts);
    instancemap.put("normaldists", new Vector()); 
    instancemap.put("normaldist",new Vector()); 
    entcodes.add("normaldists");
    entcodes.add("normaldist");
    entmap.put("normaldists","NormalDist");
    entmap.put("normaldist","NormalDist");
    eallatts = new Vector();
    allattsmap.put("NormalDist", eallatts);
    eallatts = new Vector();
    stringattsmap.put("NormalDist", eallatts);
    eallatts = new Vector();
    onerolesmap.put("NormalDist", eallatts);
    instancemap.put("differentialevolutions", new Vector()); 
    instancemap.put("differentialevolution",new Vector()); 
    entcodes.add("differentialevolutions");
    entcodes.add("differentialevolution");
    entmap.put("differentialevolutions","DifferentialEvolution");
    entmap.put("differentialevolution","DifferentialEvolution");
    eallatts = new Vector();
    eallatts.add("populationSize");
    eallatts.add("maxGenerations");
    eallatts.add("generations");
    allattsmap.put("DifferentialEvolution", eallatts);
    eallatts = new Vector();
    stringattsmap.put("DifferentialEvolution", eallatts);
    eallatts = new Vector();
    onerolesmap.put("DifferentialEvolution", eallatts);
    instancemap.put("deindividuals", new Vector()); 
    instancemap.put("deindividual",new Vector()); 
    entcodes.add("deindividuals");
    entcodes.add("deindividual");
    entmap.put("deindividuals","DEIndividual");
    entmap.put("deindividual","DEIndividual");
    eallatts = new Vector();
    eallatts.add("f");
    allattsmap.put("DEIndividual", eallatts);
    eallatts = new Vector();
    stringattsmap.put("DEIndividual", eallatts);
    eallatts = new Vector();
    onerolesmap.put("DEIndividual", eallatts);
    instancemap.put("detraits", new Vector()); 
    instancemap.put("detrait",new Vector()); 
    entcodes.add("detraits");
    entcodes.add("detrait");
    entmap.put("detraits","DETrait");
    entmap.put("detrait","DETrait");
    eallatts = new Vector();
    eallatts.add("attribute");
    eallatts.add("value");
    allattsmap.put("DETrait", eallatts);
    eallatts = new Vector();
    eallatts.add("attribute");
    stringattsmap.put("DETrait", eallatts);
    eallatts = new Vector();
    onerolesmap.put("DETrait", eallatts);
    instancemap.put("nsdes", new Vector()); 
    instancemap.put("nsde",new Vector()); 
    entcodes.add("nsdes");
    entcodes.add("nsde");
    entmap.put("nsdes","NSDE");
    entmap.put("nsde","NSDE");
    eallatts = new Vector();
    allattsmap.put("NSDE", eallatts);
    eallatts = new Vector();
    stringattsmap.put("NSDE", eallatts);
    eallatts = new Vector();
    onerolesmap.put("NSDE", eallatts);
    instancemap.put("initialises", new Vector()); 
    instancemap.put("initialise",new Vector()); 
    entcodes.add("initialises");
    entcodes.add("initialise");
    entmap.put("initialises","Initialise");
    entmap.put("initialise","Initialise");
    eallatts = new Vector();
    allattsmap.put("Initialise", eallatts);
    eallatts = new Vector();
    stringattsmap.put("Initialise", eallatts);
    eallatts = new Vector();
    onerolesmap.put("Initialise", eallatts);
    instancemap.put("evolvepopulations", new Vector()); 
    instancemap.put("evolvepopulation",new Vector()); 
    entcodes.add("evolvepopulations");
    entcodes.add("evolvepopulation");
    entmap.put("evolvepopulations","EvolvePopulation");
    entmap.put("evolvepopulation","EvolvePopulation");
    eallatts = new Vector();
    allattsmap.put("EvolvePopulation", eallatts);
    eallatts = new Vector();
    stringattsmap.put("EvolvePopulation", eallatts);
    eallatts = new Vector();
    onerolesmap.put("EvolvePopulation", eallatts);
    eallatts = new Vector();
  Vector enodes = xml.getSubnodes();
  for (int i = 0; i < enodes.size(); i++)
  { XMLNode enode = (XMLNode) enodes.get(i);
    String cname = enode.getTag();
    Vector einstances = (Vector) instancemap.get(cname); 
    if (einstances == null) 
    { einstances = (Vector) instancemap.get(cname + "s"); }
    if (einstances != null) 
    { einstances.add(enode); }
  }
  for (int j = 0; j < entcodes.size(); j++)
  { String ename = (String) entcodes.get(j);
    Vector elems = (Vector) instancemap.get(ename);
    for (int k = 0; k < elems.size(); k++)
    { XMLNode enode = (XMLNode) elems.get(k);
      String tname = enode.getAttributeValue("xsi:type"); 
      if (tname == null) 
      { tname = (String) entmap.get(ename); } 
      else 
      { int colonind = tname.indexOf(":"); 
        if (colonind >= 0)
        { tname = tname.substring(colonind + 1,tname.length()); }
      }
      res.add(ename + k + " : " + tname);
      actualtype.put(enode,tname);
    }   
  }
  for (int j = 0; j < entcodes.size(); j++) 
  { String ename = (String) entcodes.get(j); 
    Vector elems = (Vector) instancemap.get(ename); 
    for (int k = 0; k < elems.size(); k++)
    { XMLNode enode = (XMLNode) elems.get(k);
      String tname = (String) actualtype.get(enode);
      Vector tallatts = (Vector)  allattsmap.get(tname);
      Vector tstringatts = (Vector)  stringattsmap.get(tname);
      Vector toneroles = (Vector)  onerolesmap.get(tname);
      Vector atts = enode.getAttributes();
      for (int p = 0; p < atts.size(); p++) 
      { XMLAttribute patt = (XMLAttribute) atts.get(p); 
        if (patt.getName().equals("xsi:type") || patt.getName().equals("xmi:id")) {} 
        else 
        { patt.getDataDeclarationFromXsi(res,tallatts,tstringatts,toneroles,ename + k, (String) entmap.get(ename)); } 
      }
    } 
  }  
  return res; } 

  public void saveXSI(String file)
  { File outfile = new File(file); 
    PrintWriter out; 
    try { out = new PrintWriter(new BufferedWriter(new FileWriter(outfile))); }
    catch (Exception e) { return; } 
    out.println("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
    out.println("<UMLRSDS:model xmi:version=\"2.0\" xmlns:xmi=\"http://www.omg.org/XMI\">");
    for (int _i = 0; _i < mathlibs.size(); _i++)
    { MathLib mathlibx_ = (MathLib) mathlibs.get(_i);
       out.print("<mathlibs xsi:type=\"My:MathLib\"");
    out.print(" ix=\"" + mathlibx_.getix() + "\" ");
    out.print(" iy=\"" + mathlibx_.getiy() + "\" ");
    out.print(" iz=\"" + mathlibx_.getiz() + "\" ");
    out.println(" />");
  }

    for (int _i = 0; _i < normaldists.size(); _i++)
    { NormalDist normaldistx_ = (NormalDist) normaldists.get(_i);
       out.print("<normaldists xsi:type=\"My:NormalDist\"");
    out.println(" />");
  }

    for (int _i = 0; _i < differentialevolutions.size(); _i++)
    { DifferentialEvolution differentialevolutionx_ = (DifferentialEvolution) differentialevolutions.get(_i);
       out.print("<differentialevolutions xsi:type=\"My:DifferentialEvolution\"");
    out.print(" populationSize=\"" + differentialevolutionx_.getpopulationSize() + "\" ");
    out.print(" maxGenerations=\"" + differentialevolutionx_.getmaxGenerations() + "\" ");
    out.print(" generations=\"" + differentialevolutionx_.getgenerations() + "\" ");
    out.print(" population = \"");
    List differentialevolution_population = differentialevolutionx_.getpopulation();
    for (int _j = 0; _j < differentialevolution_population.size(); _j++)
    { out.print(" //@deindividuals." + deindividuals.indexOf(differentialevolution_population.get(_j)));
    }
    out.print("\"");
    out.println(" />");
  }

    for (int _i = 0; _i < deindividuals.size(); _i++)
    { DEIndividual deindividualx_ = (DEIndividual) deindividuals.get(_i);
       out.print("<deindividuals xsi:type=\"My:DEIndividual\"");
    out.print(" f=\"" + deindividualx_.getf() + "\" ");
    out.print(" traits = \"");
    List deindividual_traits = deindividualx_.gettraits();
    for (int _j = 0; _j < deindividual_traits.size(); _j++)
    { out.print(" //@detraits." + detraits.indexOf(deindividual_traits.get(_j)));
    }
    out.print("\"");
    out.println(" />");
  }

    for (int _i = 0; _i < detraits.size(); _i++)
    { DETrait detraitx_ = (DETrait) detraits.get(_i);
       out.print("<detraits xsi:type=\"My:DETrait\"");
    out.print(" attribute=\"" + detraitx_.getattribute() + "\" ");
    out.print(" value=\"" + detraitx_.getvalue() + "\" ");
    out.println(" />");
  }

    for (int _i = 0; _i < nsdes.size(); _i++)
    { NSDE nsdex_ = (NSDE) nsdes.get(_i);
       out.print("<nsdes xsi:type=\"My:NSDE\"");
    out.println(" />");
  }

    for (int _i = 0; _i < initialises.size(); _i++)
    { Initialise initialisex_ = (Initialise) initialises.get(_i);
       out.print("<initialises xsi:type=\"My:Initialise\"");
    out.println(" />");
  }

    for (int _i = 0; _i < evolvepopulations.size(); _i++)
    { EvolvePopulation evolvepopulationx_ = (EvolvePopulation) evolvepopulations.get(_i);
       out.print("<evolvepopulations xsi:type=\"My:EvolvePopulation\"");
    out.println(" />");
  }

    out.println("</UMLRSDS:model>");
    out.close(); 
  }


  public void saveCSVModel()
  { try {
      File _mathlib = new File("MathLib.csv");
      PrintWriter _out_mathlib = new PrintWriter(new BufferedWriter(new FileWriter(_mathlib)));
      for (int __i = 0; __i < mathlibs.size(); __i++)
      { MathLib mathlibx = (MathLib) mathlibs.get(__i);
        mathlibx.writeCSV(_out_mathlib);
      }
      _out_mathlib.close();
      File _normaldist = new File("NormalDist.csv");
      PrintWriter _out_normaldist = new PrintWriter(new BufferedWriter(new FileWriter(_normaldist)));
      for (int __i = 0; __i < normaldists.size(); __i++)
      { NormalDist normaldistx = (NormalDist) normaldists.get(__i);
        normaldistx.writeCSV(_out_normaldist);
      }
      _out_normaldist.close();
      File _differentialevolution = new File("DifferentialEvolution.csv");
      PrintWriter _out_differentialevolution = new PrintWriter(new BufferedWriter(new FileWriter(_differentialevolution)));
      for (int __i = 0; __i < differentialevolutions.size(); __i++)
      { DifferentialEvolution differentialevolutionx = (DifferentialEvolution) differentialevolutions.get(__i);
        differentialevolutionx.writeCSV(_out_differentialevolution);
      }
      _out_differentialevolution.close();
      File _deindividual = new File("DEIndividual.csv");
      PrintWriter _out_deindividual = new PrintWriter(new BufferedWriter(new FileWriter(_deindividual)));
      for (int __i = 0; __i < deindividuals.size(); __i++)
      { DEIndividual deindividualx = (DEIndividual) deindividuals.get(__i);
        deindividualx.writeCSV(_out_deindividual);
      }
      _out_deindividual.close();
      File _detrait = new File("DETrait.csv");
      PrintWriter _out_detrait = new PrintWriter(new BufferedWriter(new FileWriter(_detrait)));
      for (int __i = 0; __i < detraits.size(); __i++)
      { DETrait detraitx = (DETrait) detraits.get(__i);
        detraitx.writeCSV(_out_detrait);
      }
      _out_detrait.close();
      File _nsde = new File("NSDE.csv");
      PrintWriter _out_nsde = new PrintWriter(new BufferedWriter(new FileWriter(_nsde)));
      for (int __i = 0; __i < nsdes.size(); __i++)
      { NSDE nsdex = (NSDE) nsdes.get(__i);
        nsdex.writeCSV(_out_nsde);
      }
      _out_nsde.close();
      File _initialise = new File("Initialise.csv");
      PrintWriter _out_initialise = new PrintWriter(new BufferedWriter(new FileWriter(_initialise)));
      for (int __i = 0; __i < initialises.size(); __i++)
      { Initialise initialisex = (Initialise) initialises.get(__i);
        initialisex.writeCSV(_out_initialise);
      }
      _out_initialise.close();
      File _evolvepopulation = new File("EvolvePopulation.csv");
      PrintWriter _out_evolvepopulation = new PrintWriter(new BufferedWriter(new FileWriter(_evolvepopulation)));
      for (int __i = 0; __i < evolvepopulations.size(); __i++)
      { EvolvePopulation evolvepopulationx = (EvolvePopulation) evolvepopulations.get(__i);
        evolvepopulationx.writeCSV(_out_evolvepopulation);
      }
      _out_evolvepopulation.close();
    }
    catch(Exception __e) { }
  }



  public void addMathLib(MathLib oo) { mathlibs.add(oo); }

  public void addNormalDist(NormalDist oo) { normaldists.add(oo); }

  public void addDifferentialEvolution(DifferentialEvolution oo) { differentialevolutions.add(oo); }

  public void addDEIndividual(DEIndividual oo) { deindividuals.add(oo); }

  public void addDETrait(DETrait oo) { detraits.add(oo); }

  public void addNSDE(NSDE oo) { nsdes.add(oo); }

  public void addInitialise(Initialise oo) { initialises.add(oo); }

  public void addEvolvePopulation(EvolvePopulation oo) { evolvepopulations.add(oo); }



  public MathLib createMathLib()
  { MathLib mathlibx = new MathLib();
    addMathLib(mathlibx);
    return mathlibx;
  }

  public NormalDist createNormalDist()
  { NormalDist normaldistx = new NormalDist();
    addNormalDist(normaldistx);
    return normaldistx;
  }

  public DifferentialEvolution createDifferentialEvolution()
  { DifferentialEvolution differentialevolutionx = new DifferentialEvolution();
    addDifferentialEvolution(differentialevolutionx);
    return differentialevolutionx;
  }

  public DEIndividual createDEIndividual()
  { DEIndividual deindividualx = new DEIndividual();
    addDEIndividual(deindividualx);
    return deindividualx;
  }

  public DETrait createDETrait()
  { DETrait detraitx = new DETrait();
    addDETrait(detraitx);
    return detraitx;
  }

  public NSDE createNSDE()
  { NSDE nsdex = new NSDE();
    addNSDE(nsdex);
    return nsdex;
  }

  public Initialise createInitialise()
  { Initialise initialisex = new Initialise();
    addInitialise(initialisex);
    return initialisex;
  }

  public EvolvePopulation createEvolvePopulation()
  { EvolvePopulation evolvepopulationx = new EvolvePopulation();
    addEvolvePopulation(evolvepopulationx);
    return evolvepopulationx;
  }


public void setix(int ix_x) 
  { MathLib.setix(ix_x);
  for (int i = 0; i < mathlibs.size(); i++)
  { MathLib mathlibx = (MathLib) mathlibs.get(i);
    setix(mathlibx,ix_x); } }

  public void setix(MathLib mathlibx, int ix_x) 
  { mathlibx.localSetix(ix_x);
    }


public void setiy(int iy_x) 
  { MathLib.setiy(iy_x);
  for (int i = 0; i < mathlibs.size(); i++)
  { MathLib mathlibx = (MathLib) mathlibs.get(i);
    setiy(mathlibx,iy_x); } }

  public void setiy(MathLib mathlibx, int iy_x) 
  { mathlibx.localSetiy(iy_x);
    }


public void setiz(int iz_x) 
  { MathLib.setiz(iz_x);
  for (int i = 0; i < mathlibs.size(); i++)
  { MathLib mathlibx = (MathLib) mathlibs.get(i);
    setiz(mathlibx,iz_x); } }

  public void setiz(MathLib mathlibx, int iz_x) 
  { mathlibx.localSetiz(iz_x);
    }


public void setpopulationSize(DifferentialEvolution differentialevolutionx, int populationSize_x) 
  { differentialevolutionx.setpopulationSize(populationSize_x);
    }


public void setmaxGenerations(DifferentialEvolution differentialevolutionx, int maxGenerations_x) 
  { differentialevolutionx.setmaxGenerations(maxGenerations_x);
    }


public void setgenerations(DifferentialEvolution differentialevolutionx, int generations_x) 
  { differentialevolutionx.setgenerations(generations_x);
    }


  public void setpopulation(DifferentialEvolution differentialevolutionx, List populationxx) 
  {   List _oldpopulationxx = differentialevolutionx.getpopulation();
  for (int _i = 0; _i < populationxx.size(); _i++)
  { DEIndividual _xx = (DEIndividual) populationxx.get(_i);
    if (_oldpopulationxx.contains(_xx)) { }
    else { DifferentialEvolution.removeAllpopulation(differentialevolutions, _xx); }
  }
    differentialevolutionx.setpopulation(populationxx);
      }


  public void setpopulation(DifferentialEvolution differentialevolutionx, int _ind, DEIndividual deindividualx) 
  { differentialevolutionx.setpopulation(_ind,deindividualx); }
  
  public void addpopulation(DifferentialEvolution differentialevolutionx, DEIndividual populationxx) 
  {   DifferentialEvolution.removeAllpopulation(differentialevolutions,populationxx);
    differentialevolutionx.addpopulation(populationxx);
   }


  public void removepopulation(DifferentialEvolution differentialevolutionx, DEIndividual populationxx) 
  { differentialevolutionx.removepopulation(populationxx);
    }


 public void unionpopulation(DifferentialEvolution differentialevolutionx, List populationx)
  { for (int _i = 0; _i < populationx.size(); _i++)
    { DEIndividual deindividualxpopulation = (DEIndividual) populationx.get(_i);
      addpopulation(differentialevolutionx, deindividualxpopulation);
     } } 


 public void subtractpopulation(DifferentialEvolution differentialevolutionx, List populationx)
  { for (int _i = 0; _i < populationx.size(); _i++)
    { DEIndividual deindividualxpopulation = (DEIndividual) populationx.get(_i);
      removepopulation(differentialevolutionx, deindividualxpopulation);
     } } 


public void setf(DEIndividual deindividualx, double f_x) 
  { deindividualx.setf(f_x);
    }


  public void settraits(DEIndividual deindividualx, List traitsxx) 
  {     deindividualx.settraits(traitsxx);
      }


  public void settraits(DEIndividual deindividualx, int _ind, DETrait detraitx) 
  { deindividualx.settraits(_ind,detraitx); }
  
  public void addtraits(DEIndividual deindividualx, DETrait traitsxx) 
  {     deindividualx.addtraits(traitsxx);
   }


  public void removetraits(DEIndividual deindividualx, DETrait traitsxx) 
  { deindividualx.removetraits(traitsxx);
    }


 public void uniontraits(DEIndividual deindividualx, List traitsx)
  { for (int _i = 0; _i < traitsx.size(); _i++)
    { DETrait detraitxtraits = (DETrait) traitsx.get(_i);
      addtraits(deindividualx, detraitxtraits);
     } } 


 public void subtracttraits(DEIndividual deindividualx, List traitsx)
  { for (int _i = 0; _i < traitsx.size(); _i++)
    { DETrait detraitxtraits = (DETrait) traitsx.get(_i);
      removetraits(deindividualx, detraitxtraits);
     } } 


public void setattribute(DETrait detraitx, String attribute_x) 
  { detraitx.setattribute(attribute_x);
    }


public void setvalue(DETrait detraitx, double value_x) 
  { detraitx.setvalue(value_x);
    }



  public static void setSeeds(int x,int y,int z)
  { MathLib.setSeeds(x, y, z); }

  public  List AllDifferentialEvolutiongetFittest(List differentialevolutionxs)
  { 
    List result = new Vector();
    for (int _i = 0; _i < differentialevolutionxs.size(); _i++)
    { DifferentialEvolution differentialevolutionx = (DifferentialEvolution) differentialevolutionxs.get(_i);
      result.add(differentialevolutionx.getFittest());
    }
    return result; 
  }

  public void initialise2(DifferentialEvolution differentialevolutionx)
  {   differentialevolutionx.initialise2();
   }

  public void evolvepopulation1(DifferentialEvolution differentialevolutionx)
  {   differentialevolutionx.evolvepopulation1();
   }

  public void evolvepopulation3(DifferentialEvolution differentialevolutionx)
  {   differentialevolutionx.evolvepopulation3();
   }

  public void init(DEIndividual deindividualx,double x,double y)
  {   deindividualx.init(x, y);
   }

  public  List AllDEIndividualinit(List deindividualxs,double x,double y)
  { 
    List result = new Vector();
    for (int _i = 0; _i < deindividualxs.size(); _i++)
    { DEIndividual deindividualx = (DEIndividual) deindividualxs.get(_i);
      init(deindividualx,x, y);
    }
    return result; 
  }

  public DEIndividual mutate(DEIndividual deindividualx)
  { 
   DEIndividual result = null;
   result =   deindividualx.mutate();
     return result;  }

  public  List AllDEIndividualmutate(List deindividualxs)
  { 
    List result = new Vector();
    for (int _i = 0; _i < deindividualxs.size(); _i++)
    { DEIndividual deindividualx = (DEIndividual) deindividualxs.get(_i);
      result.add(mutate(deindividualx));
    }
    return result; 
  }

  public  List AllDEIndividualtoString(List deindividualxs)
  { 
    List result = new Vector();
    for (int _i = 0; _i < deindividualxs.size(); _i++)
    { DEIndividual deindividualx = (DEIndividual) deindividualxs.get(_i);
      result.add(deindividualx.toString());
    }
    return result; 
  }

  public  List AllDEIndividualfitness(List deindividualxs)
  { 
    List result = new Vector();
    for (int _i = 0; _i < deindividualxs.size(); _i++)
    { DEIndividual deindividualx = (DEIndividual) deindividualxs.get(_i);
      result.add(new Double(deindividualx.fitness()));
    }
    return result; 
  }

  public void initialise3(DEIndividual deindividualx)
  {   deindividualx.initialise3();
   }

  public void evolvepopulation2(DEIndividual deindividualx)
  {   deindividualx.evolvepopulation2();
   }

  public DETrait mutate(DETrait detraitx, double f)
  { 
   DETrait result = null;
   result =   detraitx.mutate(f);
     return result;  }

  public  List AllDETraitmutate(List detraitxs, double f)
  { 
    List result = new Vector();
    for (int _i = 0; _i < detraitxs.size(); _i++)
    { DETrait detraitx = (DETrait) detraitxs.get(_i);
      result.add(mutate(detraitx,f));
    }
    return result; 
  }



  public void killAllMathLib(List mathlibxx)
  { for (int _i = 0; _i < mathlibxx.size(); _i++)
    { killMathLib((MathLib) mathlibxx.get(_i)); }
  }

  public void killMathLib(MathLib mathlibxx)
  { if (mathlibxx == null) { return; }
   mathlibs.remove(mathlibxx);
  }



  public void killAllNormalDist(List normaldistxx)
  { for (int _i = 0; _i < normaldistxx.size(); _i++)
    { killNormalDist((NormalDist) normaldistxx.get(_i)); }
  }

  public void killNormalDist(NormalDist normaldistxx)
  { if (normaldistxx == null) { return; }
   normaldists.remove(normaldistxx);
  }



  public void killAllDifferentialEvolution(List differentialevolutionxx)
  { for (int _i = 0; _i < differentialevolutionxx.size(); _i++)
    { killDifferentialEvolution((DifferentialEvolution) differentialevolutionxx.get(_i)); }
  }

  public void killDifferentialEvolution(DifferentialEvolution differentialevolutionxx)
  { if (differentialevolutionxx == null) { return; }
   differentialevolutions.remove(differentialevolutionxx);
  }



  public void killAllDEIndividual(List deindividualxx)
  { for (int _i = 0; _i < deindividualxx.size(); _i++)
    { killDEIndividual((DEIndividual) deindividualxx.get(_i)); }
  }

  public void killDEIndividual(DEIndividual deindividualxx)
  { if (deindividualxx == null) { return; }
   deindividuals.remove(deindividualxx);
    Vector _1qrangepopulationDifferentialEvolution = new Vector();
    _1qrangepopulationDifferentialEvolution.addAll(differentialevolutions);
    for (int _i = 0; _i < _1qrangepopulationDifferentialEvolution.size(); _i++)
    { DifferentialEvolution differentialevolutionx = (DifferentialEvolution) _1qrangepopulationDifferentialEvolution.get(_i);
      if (differentialevolutionx != null && differentialevolutionx.getpopulation().contains(deindividualxx))
      { removepopulation(differentialevolutionx,deindividualxx); }
    }
  }



  public void killAllDETrait(List detraitxx)
  { for (int _i = 0; _i < detraitxx.size(); _i++)
    { killDETrait((DETrait) detraitxx.get(_i)); }
  }

  public void killDETrait(DETrait detraitxx)
  { if (detraitxx == null) { return; }
   detraits.remove(detraitxx);
    Vector _1qrangetraitsDEIndividual = new Vector();
    _1qrangetraitsDEIndividual.addAll(deindividuals);
    for (int _i = 0; _i < _1qrangetraitsDEIndividual.size(); _i++)
    { DEIndividual deindividualx = (DEIndividual) _1qrangetraitsDEIndividual.get(_i);
      if (deindividualx != null && deindividualx.gettraits().contains(detraitxx))
      { removetraits(deindividualx,detraitxx); }
    }
  }



  public void killAllNSDE(List nsdexx)
  { for (int _i = 0; _i < nsdexx.size(); _i++)
    { killNSDE((NSDE) nsdexx.get(_i)); }
  }

  public void killNSDE(NSDE nsdexx)
  { if (nsdexx == null) { return; }
   nsdes.remove(nsdexx);
  }



  public void killAllInitialise(List initialisexx)
  { for (int _i = 0; _i < initialisexx.size(); _i++)
    { killInitialise((Initialise) initialisexx.get(_i)); }
  }

  public void killInitialise(Initialise initialisexx)
  { if (initialisexx == null) { return; }
   initialises.remove(initialisexx);
  }



  public void killAllEvolvePopulation(List evolvepopulationxx)
  { for (int _i = 0; _i < evolvepopulationxx.size(); _i++)
    { killEvolvePopulation((EvolvePopulation) evolvepopulationxx.get(_i)); }
  }

  public void killEvolvePopulation(EvolvePopulation evolvepopulationxx)
  { if (evolvepopulationxx == null) { return; }
   evolvepopulations.remove(evolvepopulationxx);
  }




  
  
  public void initialise() 
  { 
    MathLib.setSeeds(1220,4556,786); 

     DifferentialEvolution de = new DifferentialEvolution();
    Controller.inst().addDifferentialEvolution(de);
    Controller.inst().setpopulationSize(de,200);
    Controller.inst().setmaxGenerations(de,200);
    Controller.inst().setgenerations(de,0);
    List _range10 = new Vector();
  _range10.addAll(Controller.inst().differentialevolutions);
  for (int _i9 = 0; _i9 < _range10.size(); _i9++)
  { DifferentialEvolution loopvar_0 = (DifferentialEvolution) _range10.get(_i9);
       Controller.inst().initialise2(loopvar_0);
  }
    List _range12 = new Vector();
  _range12.addAll(Controller.inst().deindividuals);
  for (int _i11 = 0; _i11 < _range12.size(); _i11++)
  { DEIndividual loopvar_1 = (DEIndividual) _range12.get(_i11);
       Controller.inst().initialise3(loopvar_1);
  }

  }



  
  public void evolvePopulation() 
  { 

    List _range14 = new Vector();
  _range14.addAll(Controller.inst().differentialevolutions);
  for (int _i13 = 0; _i13 < _range14.size(); _i13++)
  { DifferentialEvolution loopvar_2 = (DifferentialEvolution) _range14.get(_i13);
       Controller.inst().evolvepopulation1(loopvar_2);
  }
    List _range16 = new Vector();
  _range16.addAll(Controller.inst().deindividuals);
  for (int _i15 = 0; _i15 < _range16.size(); _i15++)
  { DEIndividual loopvar_3 = (DEIndividual) _range16.get(_i15);
       Controller.inst().evolvepopulation2(loopvar_3);
  }
    List _range18 = new Vector();
  _range18.addAll(Controller.inst().differentialevolutions);
  for (int _i17 = 0; _i17 < _range18.size(); _i17++)
  { DifferentialEvolution loopvar_4 = (DifferentialEvolution) _range18.get(_i17);
       Controller.inst().evolvepopulation3(loopvar_4);
  }

  }


 
}



